//S1_ListerNomsStyles_503f.js
// 25.03.14 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Les noms des styles

//Sert  mettre les noms des styles de paragraphes et/ou de caractres 
//dans deux blocs texte. Ces listes peuvent tre dites (supprimer des lignes 
//entires). Ensuite, lancer le script "S2_AttributsStyles", slectionner 
//l'astrisque dans le menu du dialogue. Puis "OK", et ce ne sont seulement les 
//attributs des styles des listes qui sont extraits et insrs dans un document.

//Important: Quand les styles sont groups, les noms des groupes doivent rester 
//intacts,  moins que tous les noms des styles seront supprims.
//Les noms des styles ne doivent pas tre modifis. C'est valable galement pour 
//les trois espaces insres devant chaque nom.


// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// vrifier s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// le document au premier plan
var curDoc = app.documents[0];

// mettre le point zero  zro/zro
curDoc.zeroPoint = [0,0];

// mmoriser les units de mesure
// lorsque ce n'est pas 2053991795 (= millimtres), changer  millimtres
vM = curDoc.viewPreferences.verticalMeasurementUnits;
hM = curDoc.viewPreferences.horizontalMeasurementUnits;
if (vM != 2053991795) {
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
}
if (hM != 2053991795) {
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
}

// mettre le dfaut des styles de caractres  "Aucun"
var noCharStyle = curDoc.characterStyles.item(0);
curDoc.textDefaults.appliedCharacterStyle = noCharStyle;
// mettre le dfaut des styles de paragraphes  "Paragraphe standard"
var dfParaStyle = curDoc.paragraphStyles.item(1);
curDoc.textDefaults.appliedParagraphStyle = dfParaStyle;

// supprimer les blocs s'ils sont prsents (sinon un message d'erreur 
// sera gnr lors de l'xecution du script suivant)
try {
	curDoc.textFrames.itemByName("ParaStyles").remove();
}
catch (e) {
}

try {
	curDoc.textFrames.itemByName("CharStyles").remove();
}
catch (e) {
}

// vrifier la prsence de groupes de styles de paragraphes
paraGroups = curDoc.paragraphStyleGroups;
var nPSG = paraGroups.length;

// vrifier la prsence de groupes de styles de caractres
charGroups = curDoc.characterStyleGroups;
var nCSG = charGroups.length;

//--- dresser la liste des styles de paragraphes ---//
if (nPSG == 0) {
	var allParaStyles = curDoc.paragraphStyles.everyItem().name;
	// supprimer le premier lment
	allParaStyles.shift();
}
else {
	var allParaStyles = curDoc.paragraphStyles.everyItem().name;
	// insrer trois espaces devant chaque lment
	for (var i=0; i<allParaStyles.length; i++) {
		curName = "   " + allParaStyles[i];
		allParaStyles[i] = curName;
	}
	// remplacer le premier lment par "[Root]"
	allParaStyles[0] = "[Root]";
	// une boucle  travers les groupes
	for (var i=0; i<nPSG; i++) {
		var curGroup = paraGroups[i];
		var curParaStyles = curGroup.paragraphStyles.everyItem().name;
		// insrer trois espaces devant chaque lment
		for (var k=0; k<curParaStyles.length; k++) {
			curName = "   " + curParaStyles[k];
			curParaStyles[k] = curName;
		}
		// insrer un lment avec le nom du groupe
		curParaStyles = [curGroup.name].concat(curParaStyles);
		allParaStyles = allParaStyles.concat(curParaStyles);
	}
}

// convertir la liste en chane de texte
var paraString = allParaStyles.join("\r");

// crer un bloc texte 
var paraFrame = curDoc.pages[0].textFrames.add();
paraFrame.properties = {geometricBounds:[12, 15, 285, 105.5], fillColor:"Paper", name:"ParaStyles"};

// copier la chane prpare dans ce bloc
paraFrame.parentStory.contents = paraString;

//--- dresser la liste des style de caractres ---//
if (nCSG == 0) {
	var allCharStyles = curDoc.characterStyles.everyItem().name;
	// supprimer le premier lment
	allCharStyles.shift();
}
else {
	var allCharStyles = curDoc.characterStyles.everyItem().name;
	// insrer trois espaces devant chaque lment
	for (var i=0; i<allCharStyles.length; i++) {
		curName = "   " + allCharStyles[i];
		allCharStyles[i] = curName;
	}
	// remplacer le premier lment par "[Root]"
	allCharStyles[0] = "[Root]";
	// une boucle  travers les groupes
	for (var i=0; i<nCSG; i++) {
		var curGroup = charGroups[i];
		var curCharStyles = curGroup.characterStyles.everyItem().name;
		// insrer trois espaces devant chaque lment
		for (var k=0; k<curCharStyles.length; k++) {
			curName = "   " + curCharStyles[k];
			curCharStyles[k] = curName;
		}
		// insrer un lment avec le nom du groupe
		curCharStyles = [curGroup.name].concat(curCharStyles);
		allCharStyles = allCharStyles.concat(curCharStyles);
	}
}

// convertir la liste en chane de texte
var charString = allCharStyles.join("\r");

// crer un bloc texte 
var charFrame = curDoc.pages[0].textFrames.add();
charFrame.properties = {geometricBounds:[12, 109.5, 285, 200], fillColor:"Paper", name:"CharStyles"};

// copier la chane prpare dans ce bloc
charFrame.parentStory.contents = charString;