//S2_AttributsStyles_510f.js
// 25.03.14 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Assembler les attributs des styles

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// vrifier s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// le document au premier plan
var curDoc = app.documents[0];

// mmoriser les abbrviations des units de mesure
var xm = unitsEnumToString(curDoc.viewPreferences.horizontalMeasurementUnits);
var ym = unitsEnumToString(curDoc.viewPreferences.verticalMeasurementUnits);

// vrifier la prsence de groupes de styles de paragraphes
paraGroups = curDoc.paragraphStyleGroups;
var nPSG = paraGroups.length;

// vrifier la prsence de groupes de styles de caractres
charGroups = curDoc.characterStyleGroups;
var nCSG = charGroups.length;

//--- dresser la liste des styles de paragraphes ---//
if (nPSG == 0) {
	var dlogPStyles = curDoc.paragraphStyles.everyItem().name;
	// remplacer le contenu du premier lment par un astrisque
	dlogPStyles[0] = "*";
	// insrer un lment vide au dbut
	dlogPStyles = [""].concat(dlogPStyles);
	nDlogPStyles = dlogPStyles.length;
}
else {
	pGroupNames = paraGroups.everyItem().name;
	pGroupNames = ["[Root]"].concat(pGroupNames);
	var curName;
	var dlogPStyles = curDoc.paragraphStyles.everyItem().name;
	// insrer trois espaces devant chaque lment
	for (var i=0; i<dlogPStyles.length; i++) {
		curName = "   " + dlogPStyles[i];
		dlogPStyles[i] = curName;
	}
	// remplacer le premier lment par "[Root]"
	dlogPStyles[0] = "[Root]";
	// insrer un astrisque
	dlogPStyles = ["*"].concat(dlogPStyles);
	// insrer un lment vide au dbut
	dlogPStyles = [""].concat(dlogPStyles);
	var curGroup;
	var curParaStyles;
	// une boucle  travers les groupes
	for (var i=0; i<nPSG; i++) {
		curGroup = paraGroups[i];
		curParaStyles = curGroup.paragraphStyles.everyItem().name;
		// insrer trois espaces devant chaque lment
		for (var k=0; k<curParaStyles.length; k++) {
			curName = "   " + curParaStyles[k];
			curParaStyles[k] = curName;
		}
		// insrer un lment avec le nom du groupe
		curParaStyles = [curGroup.name].concat(curParaStyles);
		dlogPStyles = dlogPStyles.concat(curParaStyles);
	}
	nDlogPStyles = dlogPStyles.length;
	// mmoriser la position des noms des groupes
	var pGroupIDs = new Array ();
	pGroupIDs.push(0);
	for (var i=2; i<nDlogPStyles; i++) {
		if (dlogPStyles[i][0] != " ") {
			pGroupIDs.push(i);
		}
	}
	// inverser l'ordre de la liste
	pGroupIDs.reverse();
}

//--- dresser la liste des styles de caractres ---//
if (nCSG == 0) {
	var dlogCStyles = curDoc.characterStyles.everyItem().name;
	// remplacer le contenu du premier lment par un astrisque
	dlogCStyles[0] = "*";
	// insrer un lment vide au dbut
	dlogCStyles = [""].concat(dlogCStyles);
	nDlogCStyles = dlogCStyles.length;
}
else {
	cGroupNames = charGroups.everyItem().name;
	cGroupNames = ["[Root]"].concat(cGroupNames);
	var dlogCStyles = curDoc.characterStyles.everyItem().name;
	// insrer trois espaces devant chaque lment
	for (var i=0; i<dlogCStyles.length; i++) {
		curName = "   " + dlogCStyles[i];
		dlogCStyles[i] = curName;
	}
	// remplacer le premier lment par "[Root]"
	dlogCStyles[0] = "[Root]";
	// insrer un astrisque
	dlogCStyles = ["*"].concat(dlogCStyles);
	// insrer un lment vide au dbut
	dlogCStyles = [""].concat(dlogCStyles);
	// une boucle  travers les groupes
	var curGroup;
	var curCharStyles;
	for (var i=0; i<nCSG; i++) {
		curGroup = charGroups[i];
		curCharStyles = curGroup.characterStyles.everyItem().name;
		// insrer trois espaces devant chaque lment
		for (var k=0; k<curCharStyles.length; k++) {
			curName = "   " + curCharStyles[k];
			curCharStyles[k] = curName;
		}
		// insrer un lment avec le nom du groupe
		curCharStyles = [curGroup.name].concat(curCharStyles);
		dlogCStyles = dlogCStyles.concat(curCharStyles);
	}
	nDlogCStyles = dlogCStyles.length;
	// mmoriser la position des noms des groupes
	var cGroupIDs = new Array ();
	cGroupIDs.push(0);
	for (var i=2; i<nDlogCStyles; i++) {
		if (dlogCStyles[i][0] != " ") {
			cGroupIDs.push(i);
		}
	}
	// inverser l'ordre de la liste
	cGroupIDs.reverse();
}

// effacer des dialogues qui sont ventuellement rests dans la mmoire
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

// crer un dialogue
var aDialog = app.dialogs.add({name:"Slectionner le style  rpertorier", canCancel:true});
with (aDialog) {
	with (dialogColumns.add()) {
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Style de paragraphes:"});
			staticTexts.add({staticLabel:" "});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var paraName = dropdowns.add({stringList:dlogPStyles, selectedIndex:0, minWidth:180});
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Style de caractres:"});
			staticTexts.add({staticLabel:" "});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var charName = dropdowns.add({stringList:dlogCStyles, selectedIndex:0, minWidth:180});
			}
		}
	}
	with (dialogColumns.add()) {
		staticTexts.add({staticLabel:"", minWidth:4});
	}
}
// montrer le dialogue
if (aDialog.show() == true) {
	// reprendre les choix de l'utilisateur
	var paraID = paraName.selectedIndex;
	var charID = charName.selectedIndex;
	// effacer le dialogue de la mmoire
	aDialog.destroy();
}
else {
	aDialog.destroy();
	exit();
}

// mmoriser le nom du document
var docName = curDoc.name;

// tester le choix de l'utilisateur
if (paraID != 0) {
	var curPara;
	var grpName;
	var newDocP = makeDoc();
	var newParaDoc = newDocP[0];
	var nParaStyles;
	var oldY1 = newDocP[1];
	var oldX1 = newDocP[2];
	var oldY2 = newDocP[3];
	var oldX2 = newDocP[4];
	var pCtr = 0;
	if (paraID == 1) {
		var paraString = "";
		try {
			// essayer de mmoriser le contenu du bloc "ParaStyles", 
			// si l'astrisque a t slectionn
			paraString = app.documents.itemByName(docName).textFrames.itemByName("ParaStyles").parentStory.contents;
		}
		catch (e) {
		}
		if (paraString != "") {
			paraStyles = paraString.split("\r");
			nParaStyles = paraStyles.length;
			// s'il n'y a pas de groupes de styles
			if (nPSG == 0) {
				for (var s=0; s<nParaStyles; s++) {
					curPara = paraStyles[s];
					getParaDefs(pCtr, curPara, "", docName, newParaDoc, false);
					pCtr++;
				}
			}
			// le traitement des groupes est plus compliqu
			else {
				for (var s=0; s<nParaStyles; s++) {
					curPara = paraStyles[s];
					if (curPara[0] != " ") {
						grpName = curPara;
					}
					else {
						curPara = curPara.slice(3);
						getParaDefs(pCtr, curPara, grpName, docName, newParaDoc, false);
						pCtr++;
					}
				}
			}
		}
		// si le bloc texte "ParaStyles" n'est pas prsent...
		else {
		// ... et s'il n'y a pas de groupes de styles...
			if (nPSG == 0) {
				for (var s=2; s<nDlogPStyles; s++) {
					curPara = dlogPStyles[s];
					getParaDefs(pCtr, curPara, "", docName, newParaDoc, false);
					pCtr++;
				}
			}
			// ... sinon, procder au traitement compliqu des groupes...
			else {
				for (var s=2; s<nDlogPStyles; s++) {
					curPara = dlogPStyles[s];
					if (curPara[0] != " ") {
						grpName = curPara;
						if (grpName != "[Root]") {
							curGroup = app.documents.itemByName(docName).paragraphStyleGroups.itemByName(grpName);
							paraStyles = curGroup.allParagraphStyles;
							var nParaStyles = paraStyles.length;
							for (var j=0; j<nParaStyles; j++) {
								curPara = paraStyles[j].name;
								getParaDefs(pCtr, curPara, grpName, docName, newParaDoc, false);
								pCtr++;
							}
						}
						else {
							paraStyles = app.documents.itemByName(docName).paragraphStyles;
							nParaStyles = paraStyles.length;
							for (var j=1; j<nParaStyles; j++) {
								curPara = paraStyles[j].name;
								getParaDefs(pCtr, curPara, grpName, docName, newParaDoc, false);
								pCtr++;
							}
						}
					}
				}
			}
		}
	}
	// lors du choix d'un autre article ce n'est que le style slectionn qui est trait ...
	else {
		curPara = dlogPStyles[paraID];
		// quand il n'y a pas de groupes de styles c'est plus simple...
		if (nPSG == 0) {
			getParaDefs(pCtr, curPara, "", docName, newParaDoc, true);
			pCtr++;
		}
		// ... sinon, il faut considrer les groupes
		else {
			// quand le nom d'un groupe est slectionn, le groupe entier est rpertori
			if (curPara[0] != " ") {
				grpName = curPara;
				if (grpName != "[Root]") {
					curGroup = app.documents.itemByName(docName).paragraphStyleGroups.itemByName(grpName);
					paraStyles = curGroup.allParagraphStyles;
					nParaStyles = paraStyles.length;
					for (var s=0; s<nParaStyles; s++) {
						curPara = paraStyles[s].name;
						getParaDefs(pCtr, curPara, grpName, docName, newParaDoc, false);
						pCtr++;
					}
				}
				else {
					paraStyles = app.documents.itemByName(docName).paragraphStyles;
					nParaStyles = paraStyles.length;
					for (var s=1; s<nParaStyles; s++) {
						curPara = paraStyles[s].name;
						getParaDefs(pCtr, curPara, grpName, docName, newParaDoc, false);
						pCtr++;
					}
				}
			}
			// lorsqu'un nom de format est slectionn, il faut extraire le nom du groupe
			else {
				grpName = undefined;
				// supprimer les trois espaces
				curPara = curPara.slice(3);
				// inverser l'ordre de la liste
				pGroupNames.reverse();
				// une boucle  travers cette liste
				for (var s=0; s<pGroupIDs.length; s++) {
					// ds que la position du groupe est plus petit que celle 
					// du style, il faut reprendre le nom du groupe
					if (pGroupIDs[s]<paraID) {
						grpName = pGroupNames[s];
						break;
					}
				}
				if (grpName != undefined) {
					getParaDefs(pCtr, curPara, grpName, docName, newParaDoc, true);
					pCtr++;
				}
			}
		}
	}
	// appeler la fonction qui restaure les prfrences
	restoreApp(oldY1, oldX1, oldY2, oldX2);
	// afficher la premire page
	app.activeWindow.activeSpread = curDoc.spreads[0];
}
// la mme procdure avec un style de caractres
if (charID != 0) {
	var charStyles;
	var curChar;
	var curGroup;
	var grpName;
	var nCharStyles;
	var newDocC = makeDoc();
	var newCharDoc = newDocC[0];
	var oldY1 = newDocC[1];
	var oldX1 = newDocC[2];
	var oldY2 = newDocC[3];
	var oldX2 = newDocC[4];
	var pCtr = 0;
	if (charID == 1) {
		var charString = "";
		try {
			// essayer de mmoriser le contenu du bloc "CharStyles", 
			// si l'astrisque a t slectionn
			charString = app.documents.itemByName(docName).textFrames.itemByName("CharStyles").parentStory.contents;
		}
		catch (e) {
		}
		if (charString != "") {
			charStyles = charString.split("\r");
			nCharStyles = charStyles.length;
			// s'il n'y a pas de groupes de styles
			if (nCSG == 0) {
				for (var s=0; s<nCharStyles; s++) {
					curChar = charStyles[s];
					getCharDefs(pCtr, curChar, "", docName, newCharDoc, false);
					pCtr++;
				}
			}
			// le traitement des groupes est plus compliqu
			else {
				for (var s=0; s<nCharStyles; s++) {
					curChar = charStyles[s];
					if (curChar[0] != " ") {
						grpName = curChar;
					}
					else {
						curChar = curChar.slice(3);
						getCharDefs(pCtr, curChar, grpName, docName, newCharDoc, false);
						pCtr++;
					}
				}
			}
		}
		// si le bloc texte "CharStyles" n'est pas prsent...
		else {
		// ... et s'il n'y a pas de groupes de styles...
			if (nCSG == 0) {
				for (var s=2; s<nDlogCStyles; s++) {
					curChar = dlogCStyles[s];
					getCharDefs(pCtr, curChar, "", docName, newCharDoc, false);
					pCtr++;
				}
			}
			// ... sinon procder au traitement compliqu des groupes...
			else {
				for (var s=2; s<nDlogCStyles; s++) {
					curChar = dlogCStyles[s];
					if (curChar[0] != " ") {
						grpName = curChar;
						if (grpName != "[Root]") {
							curGroup = app.documents.itemByName(docName).characterStyleGroups.itemByName(grpName);
							charStyles = curGroup.allCharacterStyles;
							nCharStyles = charStyles.length;
							for (var j=0; j<nCharStyles; j++) {
								curChar = charStyles[j].name;
								getCharDefs(pCtr, curChar, grpName, docName, newCharDoc, false);
								pCtr++;
							}
						}
						else {
							charStyles = app.documents.itemByName(docName).characterStyles;
							nCharStyles = charStyles.length;
							for (var j=1; j<nCharStyles; j++) {
								curChar = charStyles[j].name;
								getCharDefs(pCtr, curChar, grpName, docName, newCharDoc, false);
								pCtr++;
							}
						}
					}
				}
			}
		}
	}
	// lors du choix d'un autre article ce n'est que le style slectionn qui est trait ...
	else {
		curChar = dlogCStyles[charID];
		// quand il n'y a pas de groupes de styles c'est plus simple...
		if (nCSG == 0) {
			getCharDefs(pCtr, curChar, "", docName, newCharDoc, true);
			pCtr++;
		}
		// ... sinon, il faut considrer les groupes
		else {
			// quand le nom d'un groupe est slectionn, le groupe entier est rpertori
			if (curChar[0] != " ") {
				grpName = curChar;
				if (grpName != "[Root]") {
					curGroup = app.documents.itemByName(docName).characterStyleGroups.itemByName(grpName);
					charStyles = curGroup.allCharacterStyles;
					nCharStyles = charStyles.length;
					for (var s=0; s<nCharStyles; s++) {
						curChar = charStyles[s].name;
						getCharDefs(pCtr, curChar, grpName, docName, newCharDoc, false);
						pCtr++;
					}
				}
				else {
					charStyles = app.documents.itemByName(docName).characterStyles;
					nCharStyles = charStyles.length;
					for (var s=1; s<nCharStyles; s++) {
						curChar = charStyles[s].name;
						getCharDefs(pCtr, curChar, grpName, docName, newCharDoc, false);
						pCtr++;
					}
				}
			}
			// lorsqu'un nom de format est slectionn, il faut extraire le nom du groupe
			else {
				grpName = undefined;
				// supprimer les trois espaces
				curChar = curChar.slice(3);
				// inverser l'ordre de la liste
				cGroupNames.reverse();
				// une boucle  travers cette liste
				for (var s=0; s<cGroupIDs.length; s++) {
					// ds que la position du groupe est plus petit que celle 
					// du style, il faut reprendre le nom du groupe
					if (cGroupIDs[s]<charID) {
						grpName = cGroupNames[s];
						break;
					}
				}
				if (grpName != undefined) {
					getCharDefs(pCtr, curChar, grpName, docName, newCharDoc, true);
					pCtr++;
				}
			}
		}
	}
	// appeler la fonction qui restaure les prfrences
	restoreApp(oldY1, oldX1, oldY2, oldX2);
	// afficher la premire page
	app.activeWindow.activeSpread = curDoc.spreads[0];
}


// *************************************************************
//         lister les properties 
//         du style de paragraphe choisi
// *************************************************************
function getParaDefs(pCtr, curPara, grpName, docName, newParaDoc, oneStyle) {
	var snm = curPara;
	try {
		if (nPSG == 0) {
			curProps = app.documents.itemByName(docName).paragraphStyles.itemByName(curPara).properties;
			if (pCtr>0 && !oneStyle) {
				newParaDoc.pages.add();
			}
		}
		else {
			if (grpName != "[Root]") {
				var curGroup = app.documents.itemByName(docName).paragraphStyleGroups.itemByName(grpName);
				var curStyle = curGroup.paragraphStyles.itemByName(curPara);
				curProps = curStyle.properties;
				if (pCtr>0 && !oneStyle) {
					newParaDoc.pages.add();
				}
			}
			else {
				curProps = app.documents.itemByName(docName).paragraphStyles.itemByName(curPara).properties;
				if (pCtr>0 && !oneStyle) {
					newParaDoc.pages.add();
				}
			}
		}
	}
	catch (e) {
		return;
	}
	
	// **********************************************
	// le volet "Gnral"
	// **********************************************
	var bas;
	var gen = new Array ();
	var grp = 0;
	var nsp;
	if (nPSG != 0) {
		grp = 1;
		gen.push("\tEtat\t" + grpName);
	}
	var bon = curProps.basedOn.name;
	if (bon == undefined) {
		bas = "[Aucun style de paragraphe]";
	}
	else {
		if (grp != 0) {
			var bap = curProps.basedOn.parent.name;
			if (bap == docName) {
				bas = bon;
			}
			else {
				bas = bon + " (" + bap + ")";
			}
		}
		else {
			bas = bon;
		}
	}
	gen.push("\tD'aprs\t" + bas);
	var nxt = curProps.nextStyle.name;
	if (nxt == undefined) {
		nxt = "[Aucun style de paragraphe]";
	}
	if (grp != 0) {
		try {
			var nsp = curProps.nextStyle.parent.name;
		}
		catch (e) {
		}
		if (nsp != docName && nsp != "") {
			nxt = nxt + " (" + nsp + ")";
		}
	}
	gen.push("\tStyle suivant\t" + nxt);
	genString = gen.join("\r");
	
	// **********************************************
	// les "Formats de caractre de base"
	// **********************************************
	var scf = new Array ();
	var aft = curProps.appliedFont.name;
	var afn = aft.split("\t")[0];
	var afs = aft.split("\t")[1];
	scf.push("\tFamille de polices\t" + afn);
	scf.push("\tStyle de police\t" + afs);
	var siz = curProps.pointSize;
	scf.push("\tCorps\t" + siz + " pts");
	var led = curProps.leading;
	if (led == 1635019116) {
		var ald = curProps.autoLeading;
		led = "(" + ((siz * ald) / 100) + " pts)";
	}
	else {
		led = led + " pts";
	}
	scf.push("\tInterligne\t" + led);
	var kmd = curProps.kerningMethod;
	if (kmd == "Metrics") {
		kmd = "Mtrique";
	}
	else if (kmd == "Optical") {
		kmd = "Optique";
	}
	else if (kmd == "None") {
		kmd = "Sans";
	}
	scf.push("\tCrnage\t" + kmd);
	var trk = curProps.tracking;
	scf.push("\tApproche\t" + trk);
	var cap = curProps.capitalization;
	if (cap == 1852797549) {
		cap = "Normal";
	}
	else if (cap == 1936548720) {
		cap = "Petites capitales";
	}
	else if (cap == 1634493296) {
		cap = "Tout en capitales";
	}
	else if (cap == 1664250723) {
		cap = "Tout en petites capitales OpenType";
	}
	scf.push("\tCasse\t" + cap);
	var pos = curProps.position;
	if (pos == 1852797549) {
		pos = "Normal";
	}
	else if (pos == 1936749411) {
		pos = "Suprieur/Exposant";
	}
	else if (pos == 1935831907) {
		pos = "Infrieur/Indice";
	}
	else if (pos == 1884247155) {
		pos = "Suprieur/Exposant OpenType";
	}
	else if (pos == 1884247138) {
		pos = "Infrieur/Indice OpenType";
	}
	else if (pos == 1884247150) {
		pos = "Numrateur OpenType";
	}
	else if (pos == 1884247140) {
		pos = "Dnominateur OpenType";
	}
	scf.push("\tPosition\t" + pos);
	var und = curProps.underline;
	if (und == false) {
		und = "dsactiv";
	}
	else {
		und = "activ";
	}
	scf.push("\tSoulign\t" + und);
	var stk = curProps.strikeThru;
	if (stk == false) {
		stk = "dsactiv";
	}
	else {
		stk = "activ";
	}
	scf.push("\tBarr\t" + stk);
	var lig = curProps.ligatures;
	if (lig == false) {
		lig = "dsactiv";
	}
	else {
		lig = "activ";
	}
	scf.push("\tLigatures\t" + lig);
	var nbr = curProps.noBreak;
	if (nbr == false) {nbr = "dsactiv"}
	else if (nbr == true) {nbr = "activ"}
	scf.push("\tSans retour autom.\t" + nbr);
	stdString = scf.join("\r");
	
	// **********************************************
	// les "Formats de caractres avancs"
	// **********************************************
	var sca = new Array ();
	var hsc = curProps.horizontalScale;
	sca.push("\tEchelle horizontale\t" + hsc + "%");
	var vsc = curProps.verticalScale;
	sca.push("\tEchelle verticale\t" + vsc + "%");
	var bls = curProps.baselineShift;
	sca.push("\tDcalage vertical\t" + bls + " pts");
	var skw = curProps.skew;
	sca.push("\tInclinaison\t" + skw + "");
	var lga = curProps.appliedLanguage.name;
	sca.push("\tLangue\t" +lga);
	advString = sca.join("\r");
	
	// **********************************************
	// le volet "Retrait et espacement"
	// **********************************************
	var ind = new Array ();
	var jst = curProps.justification;
	if (jst == 1818584692) {
		jst = "Aligner  gauche";
	}
	else if (jst == 1667591796) {
		jst = "Centrer";
	}
	else if (jst == 1919379572) {
		jst = "Aligner  droite";
	}
	else if (jst == 1818915700) {
		jst = "Justifier  gauche";
	}
	else if (jst == 1919578996) {
		jst = "Justifier  droite";
	}
	else if (jst == 1667920756) {
		jst = "Justifier au centre";
	}
	else if (jst == 1718971500) {
		jst = "Justifier";
	}
	else if (jst == 1630691955) {
		jst = "Aligner au dos";
	}
	else if (jst == 1633772147) {
		jst = "Aligner  l'oppos du dos";
	}
	ind.push("\tAlignement\t" + jst);
	var brl = curProps.balanceRaggedLines;
	if (brl == 1114394470) {
		brl = "dsactiv";
	}
	else if (brl == 1114396261) {
		brl = "activ (en forme de V)";
	}
	else if (brl == 1114391921) {
		brl = "activ (rgulirement)";
	}
	else if (brl == 1114394745) {
		brl = "activ (forme pyramidale)";
	}
	ind.push("\tEquilibrer drapeau\t" + brl);
	var iea = curProps.ignoreEdgeAlignment;
	if (iea == false) { iea = "dsactiv"; }
	else if (iea == true) { iea = "activ"; }
	ind.push("\tIgnorer marge opt.\t" + iea);
	var lin = curProps.leftIndent;
	ln = convVal(xm, lin);
	ind.push("\tRetrait  gauche\t" + ln);
	var fln = curProps.firstLineIndent;
	fn = convVal(xm, fln);
	ind.push("\tRetrait de 1re ligne\t" + fn);
	var rin = curProps.rightIndent;
	rn = convVal(xm, rin);
	ind.push("\tRetrait  droite\t" + rn);
	var lli = curProps.lastLineIndent;
	li = convVal(xm, lli);
	ind.push("\tRetr. dernire ligne\t" + li);
	var spb = curProps.spaceBefore;
	sb = convVal(ym, spb);
	ind.push("\tEspace avant\t" + sb);
	var spa = curProps.spaceAfter;
	sa = convVal(ym, spa);
	ind.push("\tEspace aprs\t" + sa);
	var atb = curProps.alignToBaseline;
	if (atb == true) {
		if (curProps.gridAlignFirstLineOnly == false) {
			atb = "Toutes les lignes";
		}
		else {
			atb = "Premire ligne";
		}
	}
	else {
		atb = "Aucune ligne";
	}
	ind.push("\tAligner sur la grille\t" + atb);
	var insString = ind.join("\r");
	
	// **********************************************
	// le volet "Tabulations"
	// **********************************************
	var tbl = curProps.tabList;
	var nTabs = tbl.length;
	var tabString;
	if (nTabs == 0) {
		tabString = "\tpas de dfinition";
	}
	else {
		var aChar;
		var allTabs = new Array ();
		var curAlg;
		var curPos;
		var curLead;
		allTabs.push("\talign.\tposition\tconduite\tcaract.");
		for (var i=0; i<nTabs; i++) {
			aChar = "";
			curAlg = tbl[i].alignment;
			if (curAlg == 1818584692) {
				curAlg = "gauche";
			}
			else if (curAlg == 1667591796) {
				curAlg = "centrer";
			}
			else if (curAlg == 1919379572) {
				curAlg = "droite";
			}
			else if (curAlg == 1952604515) {
				curAlg = "align";
				aChar = tbl[i].alignmentCharacter;
			}
			curPos = tbl[i].position;
			cPos = convVal(xm, curPos);
			curLead = tbl[i].leader;
			allTabs.push("\t" + curAlg + "\t" + cPos + "\t" + curLead + "\t" + aChar);
		}
		var tabString = allTabs.join("\r");
	}
	
	// **********************************************
	// les "Filets de paragraphe"
	// **********************************************
	var rab = curProps.ruleAbove;
	if (rab == false) {
		rabString = "\tFilet au-dessus\tdsactiv";
	}
	else {
		rap = new Array ();
		rap.push("\tFilet au-dessus\tactiv");
		var raw = curProps.ruleAboveLineWeight;
		rap.push("\tGraisse\t" + raw + " pts");
		var rat = curProps.ruleAboveType.name;
		rap.push("\tType\t" + rat);
		var rac = curProps.ruleAboveColor;
		if (rac == "Text Color") {
			rac = "(Couleur du texte)";
		}
		else {
			rac = rac.name;
			if (rac == "None") { rac = "[Sans]"; }
			else if (rac == "Black") { rac = "[Noir]"; }
			else if (rac == "Paper") { rac = "[Papier]"; }
			else if (rac == "Registration") { rac = "[Reprage]"; }
		}
		rap.push("\tCouleur\t" + rac);
		var rai = curProps.ruleAboveTint;
		if (rai == -1) { rai = 100; }
		rap.push("\tTeinte\t" + rai + "%");
		var raop = curProps.ruleAboveOverPrint;
		if (raop == false) { raop = "non"; }
		else if (raop == true) { raop = "oui"; }
		else if (raop == undefined) { raop = "non dfini"; }
		rap.push("\tSurimpression\t" + raop);
		var ragc = curProps.ruleAboveGapColor;
		if (ragc == "Text Color") {
			ragc = "(Couleur du texte)";
		}
		else {
			ragc = ragc.name;
			if (ragc == "None") { ragc = "[Sans]"; }
			else if (ragc == "Black") { ragc = "[Noir]"; }
			else if (ragc == "Paper") { ragc = "[Papier]"; }
			else if (ragc == "Registration") { ragc = "[Reprage]"; }
		}
		if (ragc != "[Sans]") {
			rap.push("\tCouleur d'espace\t" + ragc);
			var ragi = curProps.ruleAboveGapTint;
			if (ragi == -1) { ragi = 100; }
			rap.push("\tTeinte d'espace\t" + ragi + "%");
			var rago = curProps.ruleAboveGapOverprint;
			if (rago == false) { rago = "non"; }
			else if (rago == true) { rago = "oui"; }
			else if (rago == undefined) { rago = "non dfini"; }
			rap.push("\tSurimpression\t" + rago);
		}
		var rawi = curProps.ruleAboveWidth;
		if (rawi == 1265399652) { rawi = "Colonne"; }
		else if (rawi == 1886681207) { rawi = "Texte"; }
		rap.push("\tLargeur\t" + rawi);
		var rao = curProps.ruleAboveOffset;
		rao = convVal(ym, rao);
		rap.push("\tDcalage\t" + rao);
		var rali = curProps.ruleAboveLeftIndent;
		rali = convVal(xm, rali);
		rap.push("\tRetrait  gauche\t" + rali);
		var rari = curProps.ruleAboveRightIndent;
		rari = convVal(xm, rari);
		rap.push("\tRetrait  droite\t" + rari);
		var kraf = curProps.keepRuleAboveInFrame;
		if (kraf == true) {
			kraf = "activ";
		}
		else {
			kraf = "dsactiv";
		}
		rap.push("\tConserver dans le bloc\t" + kraf);
		rabString = rap.join("\r");
	}
	var rbe = curProps.ruleBelow;
	if (rbe == false) {
		rbeString = "\tFilet au-dessous\tdsactiv";
	}
	else {
		rbp = new Array ();
		rbp.push("\tFilet au-dessous\tactiv");
		var rbw = curProps.ruleBelowLineWeight;
		rbp.push("\tGraisse\t" + rbw + " pts");
		var rbt = curProps.ruleBelowType.name;
		rbp.push("\tType\t" + rbt);
		var rbc = curProps.ruleBelowColor;
		if (rbc == "Text Color") {
			rbc = "(Couleur du texte)";
		}
		else {
			rbc = rbc.name;
			if (rbc == "None") { rbc = "[Sans]"; }
			else if (rbc == "Black") { rbc = "[Noir]"; }
			else if (rbc == "Paper") { rbc = "[Papier]"; }
			else if (rbc == "Registration") { rbc = "[Reprage]"; }
		}
		rbp.push("\tCouleur\t" + rbc);
		var rbi = curProps.ruleBelowTint;
		if (rbi == -1) { rbi = 100; }
		rbp.push("\tTeinte\t" + rbi + "%");
		var rbop = curProps.ruleBelowOverPrint;
		if (rbop == false) { rbop = "non"; }
		else if (rbop == true) { rbop = "oui"; }
		else if (rbop == undefined) { rbop = "non dfini"; }
		rbp.push("\tSurimpression\t" + rbop);
		var rbgc = curProps.ruleBelowGapColor;
		if (rbgc == "Text Color") {
			rbgc = "(Couleur du texte)";
		}
		else {
			rbgc = rbgc.name;
			if (rbgc == "None") { rbgc = "[Sans]"; }
			else if (rbgc == "Black") { rbgc = "[Noir]"; }
			else if (rbgc == "Paper") { rbgc = "[Papier]"; }
			else if (rbgc == "Registration") { rbgc = "[Reprage]"; }
		}
		if (rbgc != "[Sans]") {
			rbp.push("\tCouleur d'espace\t" + rbgc);
			var rbgi = curProps.ruleBelowGapTint;
			if (rbgi == -1) { rbgi = 100; }
			rbp.push("\tTeinte d'espace\t" + rbgi + "%");
			var rbgo = curProps.ruleBelowGapOverPrint;
			if (rbgo == false) { rbgo = "non"; }
			else if (rbgo == true) { rbgo = "oui"; }
			else if (rbgo == undefined) { rbgo = "non dfini"; }
			rbp.push("\tSurimpression\t" + rbgo);
		}
		var rbwi = curProps.ruleBelowWidth;
		if (rbwi == 1265399652) { rbwi = "Colonne"; }
		else if (rbwi == 1886681207) { rbwi = "Texte"; }
		rbp.push("\tLargeur\t" + rbwi);
		var rbo = curProps.ruleBelowOffset;
		rbo = convVal(ym, rbo);
		rbp.push("\tDcalage\t" + rbo);
		var rbli = curProps.ruleBelowLeftIndent;
		rbli = convVal(xm, rbli);
		rbp.push("\tRetrait  gauche\t" + rbli);
		var rbri = curProps.ruleBelowRightIndent;
		rbri = convVal(xm, rbri);
		rbp.push("\tRetrait  droite\t" + rbri);
		rbeString = rbp.join("\r");
	}
	
	// **********************************************
	// les "Options d'enchanement"
	// **********************************************
	var kee = new Array ();
	var kwn = curProps.keepWithNext;
	kee.push("\tParagr. solidaires\t" + kwn + " lignes");
	var kat = curProps.keepAllLinesTogether;
	if (kat == false) {
		var fir = curProps.keepFirstLines;
		var las = curProps.keepLastLines;
		kee.push("\tLignes solidaires\tdbut: " + fir + " lignes / fin: " + las + " lignes");
	}
	else {
		kee.push("\tLignes solidaires\tToutes les lignes");
	}
	var stp = curProps.startParagraph;
	if (stp == 1851945579) {
		kee.push("\tDbut paragraphe\tN'importe o");
	}
	else if (stp == 1667396203) {
		kee.push("\tDbut paragraphe\tColonne suivante");
	}
	else if (stp == 1164993131) {
		kee.push("\tDbut paragraphe\tPage paire suivante");
	}
	else if (stp == 1313235563) {
		kee.push("\tDbut paragraphe\tBloc suivant");
	}
	else if (stp == 1332765291) {
		kee.push("\tDbut paragraphe\tPage impaire suivante");
	}
	else if (stp == 1885500011) {
		kee.push("\tDbut paragraphe\tPage suivante");
	}
	var kesString = kee.join("\r");
	
	// **********************************************
	// le volet "Csure"
	// **********************************************
	var hyp = new Array ();
	var hpn = curProps.hyphenation;
	if (hpn == false) {
		hyp.push("\tdsactiv");
	}
	else {
		var hwl = curProps.hyphenateWordsLongerThan;
		hyp.push("\tMots d'au moins\t" + hwl + " lettres");
		var haf = curProps.hyphenateAfterFirst;
		hyp.push("\tAprs premires\t" + haf + " lettres");
		var hbl = curProps.hyphenateBeforeLast;
		hyp.push("\tAvant dernires\t" + hbl + " lettres");
		var hll = curProps.hyphenateLadderLimit;
		hyp.push("\tLimite de csure\t" + hll + " tirets");
		var hzn = curProps.hyphenationZone;
		hz = convVal(xm, hzn);
		hyp.push("\tZone de csure\t" + hz);
		var hwt = curProps.hyphenWeight;
		hyp.push("\tValeur\t" + hwt);
		var hcw = curProps.hyphenateCapitalizedWords;
		if (hcw == true) {
			hcw = "activ";
		}
		else {
			hcw = "dsactiv";
		}
		hyp.push("\tCouper mots Cap.\t" + hcw);
		var hlw = curProps.hyphenateLastWord;
		if (hlw == true) {
			hlw = "activ";
		}
		else {
			hlw = "dsactiv";
		}
		hyp.push("\tCouper dernier mot\t" + hlw);
		var hac = curProps.hyphenateAcrossColumns;
		if (hac == true) {
			hac = "activ";
		}
		else {
			hac = "dsactiv";
		}
		hyp.push("\tCsure sur la colonne\t" + hac);
	}
	var hysString = hyp.join("\r");
	
	// **********************************************
	// le volet "Justification"
	// **********************************************
	var jst = new Array ();
	var mws = curProps.minimumWordSpacing;
	var dws = curProps.desiredWordSpacing;
	var xws = curProps.maximumWordSpacing;
	jst.push("\tIntermots\t" + mws + "%\t" + dws + "%\t" + xws + "%");
	var mls = curProps.minimumLetterSpacing;
	var dls = curProps.desiredLetterSpacing;
	var xls = curProps.maximumLetterSpacing;
	jst.push("\tInterlettrage\t" + mls + "%\t" + dls + "%\t" + xls + "%");
	var mgs = curProps.minimumGlyphScaling;
	var dgs = curProps.desiredGlyphScaling;
	var xgs = curProps.maximumGlyphScaling;
	jst.push("\tEchelle glyphe\t" + mgs + "%\t" + dgs + "%\t" + xgs + "%");
	var ald = curProps.autoLeading;
	jst.push("\tInterligne auto\t" + ald + "%");
	var swj = curProps.singleWordJustification;
	if (swj == 1818584692) {
		swj = "Aligner  gauche";
	}
	else if (swj == 1667591796) {
		swj = "Centrer";
	}
	else if (swj == 1919379572) {
		swj = "Aligner  droite";
	}
	else if (swj == 1718971500) {
		swj = "Justifier";
	}
	jst.push("\tJust. d'un seul mot\t" + swj);
	var com = curProps.composer;
	if (com == "Compositeur paragraphe Adobe") {
		com = "paragraphe Adobe";
	}
	else if (com == "Compositeur ligne simple Adobe") {
		com = "ligne simple Adobe";
	}
	jst.push("\tCompositeur\t" + com);
	var jusString = jst.join("\r");
	
	// ************************************************
	// le volet "Etendue de colonnes"
	// ************************************************
	var spc = new Array ();
	var spanCol = curProps.spanColumnType;
	if (spanCol == 1163092844) { // SINGLE_COLUMN
		spc.push("\tDisposition:\tUne seule colonne");
	}
	else if (spanCol == 1936745326) { // SPAN_COLUMNS
		spc.push("\tDisposition:\tEtendue de colonnes");
		var spanCnt = curProps.spanSplitColumnCount;
		if (spanCnt == 1634495520) {
			spc.push("\tEtendue:\tTout");
		}
		else {
			spc.push("\tEtendue:\t" + spanCnt + " colonnes");
		}
		var spb = curProps.spanColumnMinSpaceBefore;
		sb = convVal(ym, spb);
		spc.push("\tEspace avant:\t" + sb);
		var spa = curProps.spanColumnMinSpaceAfter;
		sa = convVal(ym, spa);
		spc.push("\tEspace aprs:\t" + sa);
	}
	if (spanCol == 1937007470) { // SPLIT_COLUMNS
		spc.push("\tDisposition:\tScinder la colonne");
		var spanCnt = curProps.spanSplitColumnCount;
		spc.push("\tSous-colonnes:\t" + spanCnt);
		var spb = curProps.spanColumnMinSpaceBefore;
		sb = convVal(ym, spb);
		spc.push("\tEspace avant:\t" + sb);
		var spa = curProps.spanColumnMinSpaceAfter;
		sa = convVal(ym, spa);
		spc.push("\tEspace aprs:\t" + sa);
		var sig = curProps.splitColumnInsideGutter;
		ig = convVal(xm, sig);
		spc.push("\tGouttire int.:\t" + ig);
		var sog = curProps.splitColumnOutsideGutter;
		og = convVal(xm, sog);
		spc.push("\tGouttire ext.:\t" + og);
	}
	var spcString = spc.join("\r");

	// **********************************************
	// le volet "Lettrines et styles imbriqus"
	// **********************************************
	var noStyle = app.documents.itemByName(docName).characterStyles[0].name;
	var dcp = new Array ();
	var dcl = curProps.dropCapLines;
	dcp.push("Lettrines\tLignes\t" + dcl);
	var csn;
	var dcc = curProps.dropCapCharacters;
	var dst = curProps.dropCapStyle.name;
	if (dcc > 0) {
		dcp.push("\tCaractres\t" + dcc);
		if (nCSG == 0 || dst == noStyle) {
			csn = dst;
		}
		else {
			if (dst != noStyle) {
				nsp = curProps.dropCapStyle.parent.name;
				if (nsp == docName) {
					csn = dst;
				}
				else {
					csn = dst + " (" + nsp + ")";
				}
			}
			else {
				csn = noStyle;
			}
		}
		dcp.push("\tStyle de caractre\t" + dst);
		var dcd = curProps.dropcapDetail;
		if (dcd == 0) {
			dcp.push("\tAligner bord gauche\tdsactiv");
			dcp.push("\tEchelle jamb. inf.\tdsactiv");
		}
		else if (dcd == 1) {
			dcp.push("\tAligner bord gauche\tactiv");
			dcp.push("\tEchelle jamb. inf.\tdsactiv");
		}
		else if (dcd == 2) {
			dcp.push("\tAligner bord gauche\tdsactiv");
			dcp.push("\tEchelle jamb. inf.\tactiv");
		}
		else if (dcd == 3) {
			dcp.push("\tAligner bord gauche\tactiv");
			dcp.push("\tEchelle jamb. inf.\tactiv");
		}
		var dcsString = dcp.join("\r");
	}
	else {
		var dcsString = "\tLettrines\tpas de dfinition";
	}
	
	var nst = new Array ();
	if (nPSG == 0 || grpName == "[Root]") {
		var nes = app.documents.itemByName(docName).paragraphStyles.itemByName(snm).nestedStyles;
	}
	else {
		var nes = curStyle.nestedStyles;
	}
	var nStyles = nes.length;
	if (dst != noStyle) {
		nDef = nStyles-1;
		startVal = 1;
	}
	else {
		nDef = nStyles;
		startVal = 0;
	}
	if (nDef == 0) {
		nst.push("\tStyles imbriqus\tAucune dfinition");
	}
	else {
		if (nDef == 1) {
			nst.push("\tStyles imbriqus\t1 dfinition");
		}
		else {
			nst.push("\tStyles imbriqus\t" + nDef + " dfinitions");
		}
		var cst;
		var inc;
		var rep;
		var dlm;
		for (var x=startVal; x<nStyles; x++) {
			csn = nes[x].appliedCharacterStyle.name;
			if (nCSG != 0) {
				if (csn != noStyle) {
					nsp = nes[x].appliedCharacterStyle.parent.name;
					if (nsp != docName) {
						csn = csn + " (" + nsp + ")";
					}
				}
			}
			inc = nes[x].inclusive;
			if (inc == true) { inc = "sur"; }
			else { inc = "jusqu'"; }
			rep = nes[x].repetition;
			dlm = nes[x].delimiter;
			if (dlm == 1380545132) {
				nst.push("\tRpter dernire\t" + rep + "  Styles");
			}
			else {
				if      (dlm == 1380541555) { dlm = "Phrases"; }
				else if (dlm == 1380541559) { dlm = "Mots"; }
				else if (dlm == 1380541539) { dlm = "Caractres"; }
				else if (dlm == 1380541548) { dlm = "Lettres"; }
				else if (dlm == 1380541507) { dlm = "Lettrine"; }
				else if (dlm == 1380541540) { dlm = "Chiffres"; }
				else if (dlm == 1396855379) { dlm = "Caractre imbriqu de fin"; }
				else if (dlm == 1380541556) { dlm = "Caractres de tabulation"; }
				else if (dlm == 1397124194) { dlm = "Saut de ligne forc"; }
				else if (dlm == 1397319796) { dlm = "Retrait jusqu' ce point"; }
				else if (dlm == 1397645907) { dlm = "Espaces inscables"; }
				else if (dlm == 1397058899) { dlm = "Cadratins"; }
				else if (dlm == 1397059155) { dlm = "Demi-cadratins"; }
				else if (dlm == 1380541545) { dlm = "Marqueur d'objet ancr"; }
				else if (dlm == 1396797550) { dlm = "Numrotation auto des pages"; }
				else if (dlm == 1400073805) { dlm = "Marque de section"; }
				nst.push("\tStyle de caractre\t" + csn);
				nst.push("\t" + inc + "   " + rep + "\t" + dlm);
			}
		}
	}
	var nssString = nst.join("\r");
	
	var lst = new Array ();
	if (nPSG == 0 || grpName == "[Root]") {
		var nls = app.documents.itemByName(docName).paragraphStyles.itemByName(snm).nestedLineStyles;
	}
	else {
		var nls = curStyle.nestedLineStyles;
	}
	var lDef = nls.length;
	if (lDef == 0) {
		lst.push("\tStyles lig. imbriqus\taucune dfinition");
	}
	else {
		var lct;
		var rlt;
		if (lDef == 1) {
			lst.push("\tStyles lig. imbriqus\t1 dfinition");
			csn = nls[0].appliedCharacterStyle.name;
			if (nCSG != 0) {
				if (csn != noStyle) {
					nsp = nls[0].appliedCharacterStyle.parent.name;
					if (nsp != docName) {
						csn = csn + " (" + nsp + ")";
					}
				}
			}
			lct = nls[0].lineCount;
			rlt = nls[0].repeatLast;
			if (rlt == -1) {
				if (lct == 1) {
					lst.push("\tZF: " + csn + "\tpour 1 lignes");
				}
				else {
					lst.push("\tZF: " + csn + "\t" + lct + " lignes");
				}
			}
			else {
				if (rlt == 1) {
					lst.push("\tRpter dernier(s)/re(s)\t 1 lignes");
				}
				else {
					lst.push("\tRpter dernier(s)/re(s)\t" + rlt + " lignes");
				}
			}
		}
		else {
			lst.push("\tStyles lig. imbriqus\t" + lDef + " dfinitions");
			for (var x=0; x<lDef; x++) {
				csn = nls[x].appliedCharacterStyle.name;
				if (nCSG != 0) {
					if (csn != noStyle) {
						nsp = nls[x].appliedCharacterStyle.parent.name;
						if (nsp != docName) {
							csn = csn + " (" + nsp + ")";
						}
					}
				}
				lct = nls[x].lineCount;
				rlt = nls[x].repeatLast;
				if (rlt == -1) {
					if (lct == 1) {
						lst.push("\t" + csn + "\tpour 1 lignes");
				}
					else {
						lst.push("\t" + csn + "\t" + lct + " lignes");
					}
				}
				else {
					if (rlt == 1) {
						lst.push("\tRpter dernier(s)/re(s)\t 1 lignes");
					}
					else {
						lst.push("\tRpter dernier(s)/re(s)\t" + rlt + " lignes");
					}
				}
			}
		}
	}
	var nlsString = lst.join("\r");
	
	// ***********************************************
	// le volet "Style GREP"
	// ***********************************************
	var gst = new Array ();
	if (nPSG == 0 || grpName == "[Root]") {
		var ngs = app.documents.itemByName(docName).paragraphStyles.item(snm).nestedGrepStyles;
	}
	else {
		var ngs = curStyle.nestedGrepStyles;
	}
	var gDef = ngs.length;
	if (gDef == 0) {
		gst.push("\tStyle GREP\taucune dfinition");
	}
	else {
		var gxp;
		if (gDef == 1) {
			gst.push("\tStyle GREP\t1 dfinition");
			csn = ngs[0].appliedCharacterStyle.name;
			if (nCSG != 0) {
				if (csn != noStyle) {
					nsp = ngs[0].appliedCharacterStyle.parent.name;
					if (nsp != docName) {
						csn = csn + " (" + nsp + ")";
					}
				}
			}
			gxp = ngs[0].grepExpression;
			gst.push("\tAppliquer le style\t" + csn);
			gst.push("\tAu texte\t" + gxp);
		}
		else {
			gst.push("\tStyle GREP\t" + gDef + " dfinitions");
			for (var x=0; x<gDef; x++) {
				csn = ngs[x].appliedCharacterStyle.name;
				if (nCSG != 0) {
					if (csn != noStyle) {
						nsp = ngs[x].appliedCharacterStyle.parent.name;
						if (nsp != docName) {
							csn = csn + " (" + nsp + ")";
						}
					}
				}
				gxp = ngs[x].grepExpression;
				gst.push("\tAppliquer le style\t" + csn);
				gst.push("\tAu texte\t" + gxp);
			}
		}
	}
	var gstString = gst.join("\r");
	
	// **********************************************
	// le volet "Puces et numrotation"
	// **********************************************
	var ban = new Array ();
	var bnt = curProps.bulletsAndNumberingListType;
	if (bnt == 1280601711) {
		ban.push("\tType de liste\tSans");
	}
	else if (bnt == 1280598644) {
		ban.push("\tType de liste\tPuces");
		var bch = curProps.bulletChar.characterValue;
		ban.push("\tPuce\t" + bch);
		var nbt = curProps.bulletsTextAfter;
		ban.push("\tTexte aprs\t" + nbt);
		csn = curProps.bulletsCharacterStyle.name;
		if (nCSG != 0) {
			if (csn != noStyle) {
				nsp = curProps.bulletsCharacterStyle.parent.name;
				if (nsp != docName) {
					csn = csn + " (" + nsp + ")";
				}
			}
		}
		ban.push("\tStyle de caractre\t" + csn);
		ban.push("Position de la puce");
		var nba = curProps.bulletsAlignment;
		if (nba == 1818584692) { nba = "Aligner  gauche"; }
		else if (nba == 1667591796) { nba = "Centrer"; }
		else if (nba == 1919379572) { nba = "Aligner  droite"; }
		ban.push("\tAlignement\t" + nba);
		var bli = curProps.leftIndent;
		li = convVal(xm, bli);
		ban.push("\tRetrait  gauche\t" + li);
		var bfi = curProps.firstLineIndent;
		fi = convVal(xm, bfi);
		ban.push("\tRetrait de 1re ligne\t" + fi);
		try {
			var tbl = curProps.tabList;
			var btp = tbl[0].position;
		}
		catch (e) {
			var btp = 12.7;
		}
		tp = convVal(xm, btp);
		ban.push("\tPosition de la tabulation\t" + tp);
	}
	else if (bnt == 1280601709) {
		ban.push("\tType de liste\tNumros");
		var nln = curProps.appliedNumberingList.name;
		if (nln == "[Default]") {
			nln = "[Par dfaut]";
		}
		ban.push("\tListe\t" + nln);
		var nle = curProps.numberingLevel;
		ban.push("\tNiveau\t" + nle);
		var nst = curProps.numberingFormat;
		ban.push("\tFormat\t" + nst);
		var nex = curProps.numberingExpression;
		ban.push("\tNumro\t" + nex);
		csn = curProps.numberingCharacterStyle.name;
		if (nCSG != 0) {
			if (csn != noStyle) {
				nsp = curProps.numberingCharacterStyle.parent.name;
				if (nsp != docName) {
					csn = csn + " (" + nsp + ")";
				}
			}
		}
		ban.push("\tStyle de caractre\t" + csn);
		var nct = curProps.numberingContinue;
		if (nct) {
			var nar = false;
			if (nle > 1) {
				var nar = curProps.numberingApplyRestartPolicy;
			}
			if (nar) {
				ban.push("\tMode\tSuite du numro prcdent");
				ban.push("\tRecommencer num.\tNiveau prcdent quelconque");
			}
			else {
				ban.push("\tMode\tSuite du numro prcdent");
			}
		}
		else {
			var nsa = curProps.numberingStartAt;
			ban.push("\tMode\tCommencer : " + nsa);
		}
		var nna = curProps.numberingAlignment;
		if (nna == 1818584692) { nna = "Aligner  gauche"; }
		else if (nna == 1667591796) { nna = "Centrer"; }
		else if (nna == 1919379572) { nna = "Aligner  droite"; }
		ban.push("\tAlignement\t" + nna);
		var bli = curProps.leftIndent;
		li = convVal(xm, bli);
		ban.push("\tRetrait  gauche\t" + li);
		var bfi = curProps.firstLineIndent;
		fi = convVal(xm, bfi);
		ban.push("\tRetrait de 1re ligne\t" + fi);
		try {
			var tbl = curProps.tabList;
			var btp = tbl[0].position;
		}
		catch (e) {
			var btp = 12.7;
		}
		tp = convVal(xm, btp);
		ban.push("\tPosition de la tabulation\t" + tp);
	}
	var bnsString = ban.join("\r");
	
	// **********************************************
	// le volet "Couleur des caractres"
	// **********************************************
	var col = new Array ();
	var fco = curProps.fillColor.name;
	if (fco == "None") { fco = "[Sans]"; }
	else if (fco == "Black") { fco = "[Noir]"; }
	else if (fco == "Paper") { fco = "[Papier]"; }
	else if (fco == "Registration") { fco = "[Reprage]"; }
	col.push("\tCouleur\t" + fco);
	var fti = curProps.fillTint;
	if (fti == -1) {
		fti = 100;
	}
	col.push("\tTeinte\t" + fti + "%");
	var opf = curProps.overprintFill;
	if (opf == true) {
		opf = "oui";
	}
	else {
		opf = "non";
	}
	col.push("\tSurimpression\t" + opf);
	var sco = curProps.strokeColor.name;
	if (sco == "None") { sco = "[Aucun]"; }
	else if (sco == "Black") { sco = "[Noir]"; }
	else if (sco == "Paper") { sco = "[Papier]"; }
	else if (sco == "Registration") { sco = "[Reprage]"; }
	col.push("\tContour: Couleur\t" + sco);
	if (sco != "[Aucun]") {
		var sti = curProps.strokeTint;
		if (sti == -1) {
			sti = 100;
		}
		col.push("\tContour: Teinte\t" + sti + "%");
		var swt = curProps.strokeWeight;
		col.push("\tContour: Epaisseur\t" + swt + " pts");
		var ops = curProps.overprintFill;
		if (ops == true) {
			ops = "oui";
		}
		else {
			ops = "non";
		}
		col.push("\tContour: Surimpr.\t" + ops);
		var mil = curProps.miterLimit;
		col.push("\tContour\tPointe: " + mil + " x");
		var sta = curProps.strokeAlignment;
		if (sta = 1936998735) {
			col.push("\tAlignement contours\taligner sur l'extrieur");
		}
		else if (sta = 1936998723) {
			col.push("\tAlignement contours\tcentrer");
		}
		var ejo = curProps.endJoin;
		if (ejo = 1835691886) {
			col.push("\tSommet\ten pointe");
		}
		else if (ejo = 1919577966) {
			col.push("\tSommet\ten arrondi");
		}
		else if (ejo = 1651142510) {
			col.push("\tSommet\ten biseau");
		}
	}
	var colString = col.join("\r");
	
	// **********************************************
	// le volet "Fonctionnalits OpenType"
	// **********************************************
	var otf = new Array ();
	var vCtr = 0;
	var oti = curProps.otfTitling;
	if (oti == true) {
		otf.push("\tVariantes titrage\tactiv");
		vCtr++;
	}
	var ofs = curProps.otfSwash;
	if (ofs == true) {
		otf.push("\tVariantes ornes\tactiv");
		vCtr++;
	}
	var oca = curProps.otfContextualAlternate;
	if (oca == true) {
		otf.push("\tVar. contextuelles\tactiv");
		vCtr++;
	}
	var ord = curProps.otfOrdinal;
	if (ord == true) {
		otf.push("\tOrdinaux\tactiv");
		vCtr++;
	}
	var fra = curProps.otfFraction;
	if (fra == true) {
		otf.push("\tFractions\tactiv");
		vCtr++;
	}
	var lig = curProps.otfDiscretionaryLigature;
	if (lig == true) {
		otf.push("\tLigatures cond.\tactiv");
		vCtr++;
	}
	var zer = curProps.otfSlashedZero;
	if (zer == true) {
		otf.push("\tZro barr\tactiv");
		vCtr++;
	}
	if (vCtr == 0) {
		otf.push("\tCases  cocher\taucune n'est active");
	}
	var ofs = curProps.otfFigureStyle;
	if (ofs == 1147563124) {
		otf.push("\tStyle de chiffre\tStyle de chiffre par dfaut");
	}
	else if (ofs == 1330932848) {
		otf.push("\tStyle de chiffre\tChiffres arabes alig. prop.");
	}
	else if (ofs == 1330933619) {
		otf.push("\tStyle de chiffre\tCaractres elzvir proport.");
	}
	else if (ofs == 1330931316) {
		otf.push("\tStyle de chiffre\tChiffres arabes alig. tabul.");
	}
	else if (ofs == 1330933620) {
		otf.push("\tStyle de chiffre\tCaractres elzvir tabulaires");
	}
	var pof = curProps.positionalForm;
	if (pof == 1852796517) {
		otf.push("\tFormes positionnelles\tForme gnrale");
	}
	else if (pof == 1634756205) {
		otf.push("\tFormes positionnelles\tForme automatique");
	}
	else if (pof == 1768843636) {
		otf.push("\tFormes positionnelles\tForme initiale");
	}
	else if (pof == 1835361385) {
		otf.push("\tFormes positionnelles\tForme mdiale");
	}
	else if (pof == 1718185569) {
		otf.push("\\tFormes positionnelles\tForme finale");
	}
	else if (pof == 1769172844) {
		otf.push("\tFormes positionnelles\tForme isole");
	}
	var oss = curProps.otfStylisticSets;
	var moreThanOne = false;
	if (oss == 0) {
		otf.push("\tJeux stylistiques\tAucun");
	}
	else {
		if      (oss ==       2) { oss =  "1"; }
		else if (oss ==       4) { oss =  "2"; }
		else if (oss ==       8) { oss =  "3"; }
		else if (oss ==      16) { oss =  "4"; }
		else if (oss ==      32) { oss =  "5"; }
		else if (oss ==      64) { oss =  "6"; }
		else if (oss ==     128) { oss =  "7"; }
		else if (oss ==     256) { oss =  "8"; }
		else if (oss ==     512) { oss =  "9"; }
		else if (oss ==    1024) { oss = "10"; }
		else if (oss ==    2048) { oss = "11"; }
		else if (oss ==    4096) { oss = "12"; }
		else if (oss ==    8192) { oss = "13"; }
		else if (oss ==   16384) { oss = "14"; }
		else if (oss ==   32768) { oss = "15"; }
		else if (oss ==   65536) { oss = "16"; }
		else if (oss ==  131072) { oss = "17"; }
		else if (oss ==  262144) { oss = "18"; }
		else if (oss ==  524288) { oss = "19"; }
		else if (oss == 1048576) { oss = "20"; }
		else {
			moreThanOne = true;
			if (oss == 2097150) {
				otf.push("\tJeux stylistiques\tJeux 1  20");
			}
			else {
				var valList = new Array (1048576, 524288, 262144, 131072, 65536, 32768, 16384, 8192, 4096, 2048, 1024, 512, 256, 128, 64, 32, 16, 8, 4, 2);
				var indList = new Array (20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1);
				var setList = new Array ();
				for (var i=0; i<20; i++) {
					curVal = oss - valList[i];
					if (curVal > 0) {
						oss = curVal;
						setList.push(indList[i]);
					}
					else if (oss == valList[i]) {
						setList.push(indList[i]);
						break;
					}
				}
				setList.reverse();
				setString = setList.join(", ");
				otf.push("\tJeux stylistiques\tJeux " + setString);
			}
		}
		if (!moreThanOne) {
			otf.push("\tJeux stylistiques\tJeu " + oss);
		}
	}
	var otfString = otf.join("\r");
	
	// **********************************************
	// le volet "Options de soulignement"
	// **********************************************
	var uac = curProps.underline;
	if (uac == false) {
		undString = "\tSouligner\tdsactiv";
	}
	else {
		var und = new Array ();
		var unw = curProps.underlineWeight;
		if (unw == -9999) {
			und.push("\tGraisse\tAutomatique");
		}
		else {
			und.push("\tGraisse\t" + unw + " pts");
		}
		var uno = curProps.underlineOffset;
		if (uno == -9999) {
			und.push("\tDcalage\tAutomatique");
		}
		else {
			und.push("\tDcalage\t" + uno + " pts");
		}
		var unt = curProps.underlineType.name;
		und.push("\tType\t" + unt);
		var unc = curProps.underlineColor;
		if (unc == "Text Color") {
			unc = "(Couleur du texte)";
		}
		else {
			unc = unc.name;
			if (unc == "None") { unc = "[Sans]"; }
			else if (unc == "Black") { unc = "[Noir]"; }
			else if (unc == "Paper") { unc = "[Papier]"; }
			else if (unc == "Registration") { unc = "[Reprage]"; }
		}
		und.push("\tCouleur\t" + unc);
		var uni = curProps.underlineTint;
		if (uni == -1) { uni = 100; }
		und.push("\tTeinte\t" + uni + "%");
		var unop = curProps.underlineOverprint;
		if (unop == false) { unop = "non"; }
		else if (unop == true) { unop = "oui"; }
		und.push("\tSurimpression\t" + unop);
		if (unt != "Plein") {
			var ungc = curProps.underlineGapColor;
			if (ungc == "Text Color") {
				ungc = "(Couleur du texte)";
			}
			else {
				ungc = ungc.name;
				if (ungc == "None") { ungc = "[Sans]"; }
				else if (ungc == "Black") { ungc = "[Noir]"; }
				else if (ungc == "Paper") { ungc = "[Papier]"; }
				else if (ungc == "Registration") { ungc = "[Reprage]"; }
			}
			und.push("\tCouleur espace\t" + ungc);
			var ungi = curProps.underlineGapTint;
			if (ungi == -1) { ungi = 100; }
			und.push("\tTeinte espace\t" + ungi + "%");
			var ungo = curProps.underlineGapOverprint;
			if (ungo == false) { ungo = "non"; }
			else if (ungo == true) { ungo = "oui"; }
			else if (ungo == undefined) { ungo = "non dfini"; }
			und.push("\tSurimpression\t" + ungo);
		}
		undString = und.join("\r");
	}
	
	// **********************************************
	// le volet "Options de texte barr"
	// **********************************************
	var sac = curProps.strikeThru;
	if (sac == false) {
		var strString = "\tBarrer\tdsactiv";
	}
	else {
		var str = new Array ();
		var stw = curProps.strikeThroughWeight;
		if (stw == -9999) {
			str.push("\tGraisse\tAutomatique");
		}
		else {
			str.push("\tGraisse\t" + stw + " pts");
		}
		var sto = curProps.strikeThroughOffset;
		if (sto == -9999) {
			str.push("\tDcalage\tAutomatique");
		}
		else {
			str.push("\tDcalage\t" + sto + " pts");
		}
		var stt = curProps.strikeThroughType.name;
		str.push("\tType\t" + stt);
		var stc = curProps.strikeThroughColor;
		if (stc == "Text Color") {
			stc = "(Couleur du texte)";
		}
		else {
			stc = stc.name;
			if (stc == "None") { stc = "[Sans]"; }
			else if (stc == "Black") { stc = "[Noir]"; }
			else if (stc == "Paper") { stc = "[Papier]"; }
			else if (stc == "Registration") { stc = "[Reprage]"; }
		}
		str.push("\tCouleur\t" + stc);
		var sti = curProps.strikeThroughTint;
		if (sti == -1) { sti = 100; }
		str.push("\tTeinte\t" + sti + "%");
		var skop = curProps.strikeThroughOverprint;
		if (skop == false) { skop = "non"; }
		else if (skop == true) { skop = "oui"; }
		str.push("\tSurimpression\t" + skop);
		if (stt != "Plein") {
			var stgc = curProps.strikeThroughGapColor;
			if (stgc == "Text Color") {
				stgc = "(Couleur du texte)";
			}
			else {
				stgc = stgc.name;
				if (stgc == "None") { stgc = "[Sans]"; }
				else if (stgc == "Black") { stgc = "[Noir]"; }
				else if (stgc == "Paper") { stgc = "[Papier]"; }
				else if (stgc == "Registration") { stgc = "[Reprage]"; }
			}
			str.push("\tCouleur espace\t" + stgc);
			var stgi = curProps.strikeThroughGapTint;
			if (stgi == -1) { stgi = 100; }
			str.push("\tTeinte espace\t" + stgi + "%");
			var stgo = curProps.strikeThroughGapOverprint;
			if (stgo == false) { stgo = "non"; }
			else if (stgo == true) { stgo = "oui"; }
			else if (stgo == undefined) { stgo = "non dfini"; }
			str.push("\tSurimpression\t" + stgo);
		}
		strString = str.join("\r");
	}
	
	// **********************************************
	// crer un bloc texte
	var newFrame = newParaDoc.pages.item(-1).textFrames.add();
	newFrame.properties = {geometricBounds:[12, 15, 285, 200]};
	// deux colonnes 
	newFrame.textFramePreferences.textColumnCount = 2;
	
	// prparer une nouvelle liste
	var propsList = new Array ();
	
	// ajouter les lments
	propsList.push("Document  " + docName);
	propsList.push("\r\tNom du style\t" + snm);
	propsList.push(genString);
	propsList.push("\rFormats de caractres de base");
	propsList.push(stdString);
	propsList.push("\rFormats de caractres avancs");
	propsList.push(advString);
	propsList.push("\rRetrait et espacement");
	propsList.push(insString);
	if (tabString == "\tnon dfini") {
		propsList.push("\rTabulations\t\tnon dfini");
	}
	else {
		propsList.push("\rTabulations");
		propsList.push(tabString);
	}
	if (rabString == "\tFilet au-dessus\tnon activ" && rbeString == "\tFilet au-dessous\tnon activ") {
		propsList.push("\rFilets de paragraphe\t\tnon activs");
	}
	else {
		propsList.push("\rFilets de paragraphe");
		propsList.push(rabString);
		propsList.push(rbeString);
	}
	propsList.push("\rOptions d'enchanement");
	propsList.push(kesString);
	propsList.push("\rCsure");
	propsList.push(hysString);
	propsList.push("\rJustification");
	propsList.push(jusString);
	if (spcString == "\tDisposition:\tUne seule colonne") {
		propsList.push("\rEtendue de colonnes\t\tUne seule colonne");
	}
	else {
		propsList.push("\rEtendue de colonnes");
		propsList.push(spcString);
	}
	if ((dcsString.indexOf("aucune") != -1) && (nssString.indexOf("aucune") != -1) && (nlsString.indexOf("aucune") != -1)) {
		propsList.push("\rLettrines et styles imbriqus\tpas de dfinition");
	}
	else {
		propsList.push("\rLettrines et styles imbriqus");
		propsList.push(dcsString);
		propsList.push(nssString);
		propsList.push(nlsString);
	}
	if (gstString == "\tStyle GREP\tpas de dfinition") {
		propsList.push("\rStyle GREP\t\tpas de dfinition");
	}
	else {
		propsList.push("\rStyle GREP");
		propsList.push(gstString);
	}
	if (bnsString == "\tListentyp\tOhne") {
		propsList.push("\rPuces et numrotation\tOhne");
	}
	else {
		propsList.push("\rPuces et numrotation");
		propsList.push(bnsString);
		propsList.push("\rCouleur des caractres");
		propsList.push(colString);
		propsList.push("\rFonctionnalits OpenType");
		propsList.push(otfString);
	}
	if (undString == "\tSoulignement\tnon activ") {
		propsList.push("\rOptions de soulignement\tnon activ");
	}
	else {
		propsList.push("\rOptions de soulignement");
		propsList.push(undString);
	}
	if (strString == "\tTexte barr\tnon activ") {
		propsList.push("\rOptions de texte barr\tnon activ");
	}
	else {
		propsList.push("\rOptions de texte barr");
		propsList.push(strString);
	}

	// convertir la liste en chane de caractres...
	var propsString = propsList.join("\r");
	// ... l'insrer dans le bloc texte...
	var curStory = newFrame.parentStory;
	curStory.contents = propsString;
	// ... et la formater
	try {
		curStory.appliedParagraphStyle = newParaDoc.paragraphStyles.item("02_definitions");
	}
	catch (e) {
	}
	// un formatage spcial pour les dfinitions de tabulations ventuelles
	if (!tabString.match("dfinition")) {
		var specTabs = new Array (4);
		specTabs[0] = {alignment:TabStopAlignment.rightAlign, position:17};
		specTabs[1] = {alignment:TabStopAlignment.leftAlign, position:21};
		specTabs[2] = {alignment:TabStopAlignment.leftAlign, position:56};
		specTabs[3] = {alignment:TabStopAlignment.leftAlign, position:76};
		try {
			curStory.paragraphs.itemByRange(39+grp, 40+grp+nTabs).tabList = specTabs;
		}
		catch (e) {
		}
	}
	// formater les soustitres
	try {
		curStory.paragraphs.item(0).appliedParagraphStyle = newParaDoc.paragraphStyles.item("01_soustitre");
	}
	catch (e) {
	}
	var nParas = curStory.paragraphs.length;
	for (var i=0; i<nParas; i++) {
		if (curStory.paragraphs[i].characters.length == 1) {
			try {
				curStory.paragraphs.item(i+1).appliedParagraphStyle = newParaDoc.paragraphStyles.item("01_soustitre");
			}
			catch (e) {
			}
		}
	}
	// rtablir le style "Regular" de quelques caractres
	try {
		curStory.paragraphs.item(0).characters.itemByRange(0, 9).fontStyle = "Regular";
	}
	catch (e) {
	}
	try {
		curStory.paragraphs.item(2).characters.itemByRange(0,13).fontStyle = "Regular";
	}
	catch (e) {
	}
	
	// tester le nombre de lignes de trois paragraphes et insrer un shift-return si ncessaire
	var testPara1 = curStory.paragraphs.item(2); // nom du style
	if (testPara1.lines.length == 2) {
		try {
			testPara1.characters.item(13).contents = 1397124194;
			testPara1.insertionPoints.item(14).contents = 1397909876;
		}
		catch (e) {
		}
	}
	var testPara2 = curStory.paragraphs.item(3+grp); // bas sur
	if (testPara2.lines.length == 2) {
		try {
			testPara2.characters.item(8).contents = 1397124194;
			testPara2.insertionPoints.item(9).contents = 1397909876;
		}
		catch (e) {
		}
	}
	var testPara3 = curStory.paragraphs.item(4+grp); // style suivant
	if (testPara3.lines.length == 2) {
		try {
			testPara3.characters.item(14).contents = 1397124194;
			testPara3.insertionPoints.item(15).contents = 1397909876;
		}
		catch (e) {
		}
	}
	var testPara4 = curStory.paragraphs.item(25+grp); // langue
	if (testPara4.lines.length == 2) {
		try {
			testPara4.characters.item(9).contents = 1397124194;
			testPara4.insertionPoints.item(10).contents = 1397909876;
		}
		catch (e) {
		}
	}
	
	// passer en suprieur une abrviation
	try {
		curStory.paragraphs[32+grp].characters.itemByRange(13, 14).position = 1936749411; //superscript
	}
	catch (e) {
	}
	
	// appliquer un tableautage spcial  "Justification"
	var startPara = 0;
	for (var i = 50; i<curStory.paragraphs.length; i++) {
		curPara = curStory.paragraphs[i];
		if (curPara.fontStyle == "Bold") {
			if (curPara.contents.match("Justification")) {
				startPara = i;
				break;
			}
		}
	}
	if (startPara != 0) {
		var justTabs = new Array (4);
		justTabs[0] = {alignment:TabStopAlignment.rightAlign, position:37};
		justTabs[1] = {alignment:TabStopAlignment.rightAlign, position:51};
		justTabs[2] = {alignment:TabStopAlignment.rightAlign, position:66};
		justTabs[3] = {alignment:TabStopAlignment.rightAlign, position:81};
		try {
			curStory.paragraphs.itemByRange(startPara+1, startPara+3).tabList = justTabs;
		}
		catch (e) {
		}
	}
	// supprimer les Returns entre les paragraphes
	app.findTextPreferences = app.changeTextPreferences = null;
	app.findTextPreferences.findWhat = "\r\r";
	app.changeTextPreferences.changeTo = "\r";
	curStory.changeText();
	app.findTextPreferences = app.changeTextPreferences = null;

	// tester si le texte dborde; si oui, crer un bloc dbord
	if (newFrame.overflows) {
		var overFlowFrame = newParaDoc.pages.item(-1).textFrames.add();
		overFlowFrame.properties = {geometricBounds:[12, 215, 285, 307]};
		newFrame.nextTextFrame = overFlowFrame;
		overFlowFrame.textFramePreferences.verticalJustification = VerticalJustification.BOTTOM_ALIGN;
	}
}

// *************************************************************
//         lister les properties 
//         du style de caractres choisi
// *************************************************************
function getCharDefs(pCtr, curChar, grpName, docName, newCharDoc, oneStyle) {
	var snm = curChar;
	try {
		if (nCSG == 0) {
			curProps = app.documents.itemByName(docName).characterStyles.item(curChar).properties;
			if (pCtr>1 && pCtr%2==0) {
				newCharDoc.pages.add();
			}
		}
		else {
			if (grpName != "[Root]") {
				var curGroup = app.documents.itemByName(docName).characterStyleGroups.itemByName(grpName);
				var curStyle = curGroup.characterStyles.item(curChar);
				curProps = curStyle.properties;
				if (pCtr>1 && pCtr%2==0) {
					newCharDoc.pages.add();
				}
			}
			else {
				curProps = app.documents.itemByName(docName).characterStyles.item(curChar).properties;
				if (pCtr>1 && pCtr%2==0) {
					newCharDoc.pages.add();
				}
			}
		}
	}
	catch (e) {
		return;
	}
	
	// **********************************************
	// le volet "Gnral"
	// **********************************************
	var bas;
	var gen = new Array ();
	var grp = 0;
	if (nCSG != 0) {
		grp = 1;
		gen.push("\tEtat\t" + grpName);
	}
	var bon = curProps.basedOn.name;
	if (bon == undefined) {
		bas = "[Sans]";
	}
	else {
		if (grp != 0) {
			var bap = curProps.basedOn.parent.name;
			if (bap == docName) {
				bap = bon;
			}
			bas = bon + " (" + bap + ")";
		}
		else {
			bas = bon;
		}
	}
	gen.push("\tD'aprs\t" + bas);
	genString = gen.join("\r");
	
	// **********************************************
	// les "Formats de caractres de base"
	// **********************************************
	var scf = new Array ();
	var aft = curProps.appliedFont;
	if (aft == "" || aft == 1851876449) {
		aft = "non dfinie";
	}
	scf.push("\tFamille de police\t" + aft);
	var afs = curProps.fontStyle;
	if (afs == 1851876449) {
		afs = "non dfini";
	}
	scf.push("\tStyle de police\t" + afs);
	var siz = curProps.pointSize;
	if (siz != 1851876449) {
		scf.push("\tCorps\t" + siz + " pts");
	}
	else {
		scf.push("\tCorps\tnon dfini");
	}
	var led = curProps.leading;
	if (led == 1635019116) {
		var ald = curProps.autoLeading;
		led = "(" + ((siz * ald) / 100) + " pts)";
	}
	else if (led == 1851876449) {
		led = "non dfini";
	}
	else {
		led = led + " pts";
	}
	scf.push("\tInterligne\t" + led);
	var kmd = curProps.kerningMethod;
	if (kmd == "Metrics") {
		kmd = "Mtrique";
	}
	else if (kmd == "Optical") {
		kmd = "Optique";
	}
	else if (kmd == "None") {
		kmd = "Sans";
	}
	else if (kmd == 1851876449) {
		kmd = "non dfini";
	}
	scf.push("\tCrnage\t" + kmd);
	var trk = curProps.tracking;
	if (trk == 1851876449) {
		trk = "non dfinie";
	}
	scf.push("\tApproche\t" + trk);
	var cap = curProps.capitalization;
	if (cap == 1852797549) {
		cap = "Normal";
	}
	else if (cap == 1936548720) {
		cap = "Petites capitales";
	}
	else if (cap == 1634493296) {
		cap = "Tout en capitales";
	}
	else if (cap == 1664250723) {
		cap = "Tout en petites capitales OpenType";
	}
	else if (cap == 1851876449) {
		cap = "non dfinie";
	}
	scf.push("\tCasse\t" + cap);
	var pos = curProps.position;
	if (pos == 1852797549) {
		pos = "Normal";
	}
	else if (pos == 1936749411) {
		pos = "Suprieur/Exposant";
	}
	else if (pos == 1935831907) {
		pos = "Infrieur/Indice";
	}
	else if (pos == 1884247155) {
		pos = "Suprieur/Exposant OpenType";
	}
	else if (pos == 1884247138) {
		pos = "Infrieur/Indice OpenType";
	}
	else if (pos == 1884247150) {
		pos = "Numrateur OpenType";
	}
	else if (pos == 1884247140) {
		pos = "Dnominateur OpenType";
	}
	else if (pos == 1851876449) {
		pos = "non dfinie";
	}
	scf.push("\tPosition\t" + pos);
	var und = curProps.underline;
	if (und == false) {
		und = "dsactiv";
	}
	else if (und == true) {
		und = "activ";
	}
	else if (und == 1851876449) {
		und = "non dfini";
	}
	scf.push("\tSoulign\t" + und);
	var stk = curProps.strikeThru;
	if (stk == false) {
		stk = "dsactiv";
	}
	else if (stk == true) {
		stk = "activ";
	}
	else if (stk == 1851876449) {
		stk = "non dfini";
	}
	scf.push("\tBarr\t" + stk);
	var lig = curProps.ligatures;
	if (lig == false) {
		lig = "dsactiv";
	}
	else if (lig == true) {
		lig = "activ";
	}
	else if (lig == 1851876449) {
		lig = "non dfini";
	}
	scf.push("\tLigatures\t" + lig);
	var nbr = curProps.noBreak;
	if (nbr == false) {nbr = "dsactiv"}
	else if (nbr == true) {nbr = "activ"}
	else if (nbr == 1851876449) {nbr = "non dfini";}
	scf.push("\tSans retour autom.\t" + nbr);
	stdString = scf.join("\r");
	
	// **********************************************
	// les "Formats de caractres avancs"
	// **********************************************
	var sca = new Array ();
	var hsc = curProps.horizontalScale;
	if (hsc != 1851876449) {
		sca.push("\tEchelle horizontale\t" + hsc + "%");
	}
	else {
		sca.push("\tEchelle horizontale\tnon dfinie");
	}
	var vsc = curProps.verticalScale;
	if (vsc != 1851876449) {
		sca.push("\tEchelle verticale\t" + vsc + "%");
	}
	else {
		sca.push("\tEchelle verticale\tnon dfinie");
	}
	var bls = curProps.baselineShift;
	if (bls != 1851876449) {
		sca.push("\tDcalage vertical\t" + bls + " pts");
	}
	else {
		sca.push("\tDcalage vertical\tnon dfini");
	}
	var skw = curProps.skew;
	if (skw != 1851876449) {
		sca.push("\tInclinaison\t" + skw + "");
	}
	else {
		sca.push("\tInclinaison\tnon dfinie");
	}
	try {
		var lga = curProps.appliedLanguage.name;
		if (lga == null) {
			lga = "non dfinie";
		}
		sca.push("\tLangue\t" +lga);
	}
	catch (e) {
		sca.push("\tLangue\tnon dfinie");
	}
	advString = sca.join("\r");
	
	// **********************************************
	// le volet "Couleur des caractres"
	// **********************************************
	var col = new Array ();
	try {
		var fco = curProps.fillColor.name;
		if (fco == "None") { fco = "[Sans]" }
		else if (fco == "Black") { fco = "[Noir]" }
		else if (fco == "Paper") { fco = "[Papier]" }
		else if (fco == "Registration") { fco = "[Reprage]" }
		col.push("\tCouleur\t" + fco);
	}
	catch (e) {
		col.push("\tCouleur\tnon dfinie");
	}
	var fti = curProps.fillTint;
	if (fti != 1851876449) {
		if (fti == -1) {
			fti = 100;
		}
		col.push("\tTeinte\t" + fti + "%");
	}
	else {
		col.push("\tTeinte\tnon dfinie");
	}
	var opf = curProps.overprintFill;
	if (opf == true) {
		opf = "oui";
	}
	else if (opf == false) {
		opf = "non";
	}
	else if (opf == 1851876449) {
		opf = "non dfinie";
	}
	col.push("\tSurimpression\t" + opf);
	try {
		var sco = curProps.strokeColor.name;
		if (sco == "None") { sco = "[Sans]" }
		else if (sco == "Black") { sco = "[Noir]" }
		else if (sco == "Paper") { sco = "[Papier]" }
		else if (sco == "Registration") { sco = "[Reprage]" }
		col.push("\tContour: Couleur\t" + sco);
	}
	catch (e) {
		col.push("\tContour: Couleur\tnon dfinie");
	}
	var sti = curProps.strokeTint;
	if (sti != 1851876449) {
		if (sti == -1) {
			sti = 100;
		}
		col.push("\tContour: Teinte\t" + sti + "%");
	}
	else {
		col.push("\tContour: Teinte\tnon dfinie");
	}
	var swt = curProps.strokeWeight;
	if (swt != 1851876449) {
		col.push("\tContour: Epaisseur\t" + swt + " pts");
	}
	else {
		col.push("\tContour: Epaisseur\tnon dfinie");
	}
	var ops = curProps.overprintFill;
	if (ops == true) {
		ops = "oui";
	}
	else if (ops == false) {
		ops = "non";
	}
	else if (ops == 1851876449) {
		ops = "non dfinie";
	}
	col.push("\tContour: Surimpr.\t" + ops);
	var mil = curProps.miterLimit;
	if (mil != 1851876449) {
		col.push("\tContour\tPointe: " + mil + " x");
	}
	else {
		col.push("\tContour\tPointe: non dfinie");
	}
	var sta = curProps.strokeAlignment;
	if (sta = 1936998735) {
		col.push("\tAlignement contours\taligner sur l'extrieur");
	}
	else if (sta = 1936998723) {
		col.push("\tAlignement contours\tcentrer");
	}
	var ejo = curProps.endJoin;
	if (ejo = 1835691886) {
		col.push("\tSommet\ten pointe");
	}
	else if (ejo = 1919577966) {
		col.push("\tSommet\ten arrondi");
	}
	else if (ejo = 1651142510) {
		col.push("\tSommet\ten biseau");
	}
	var colString = col.join("\r");
	
	// **********************************************
	// le volet "Fonctionnalits OpenType"
	// **********************************************
	var otf = new Array ();
	var vCtr = 0;
	var oti = curProps.otfTitling;
	if (oti == true) {
		otf.push("\tVariantes titrage\tactiv");
		vCtr++;
	}
	var ofs = curProps.otfSwash;
	if (ofs == true) {
		otf.push("\tVariantes ornes\tactiv");
		vCtr++;
	}
	var oca = curProps.otfContextualAlternate;
	if (oca == true) {
		otf.push("\tVar. contextuelles\tactiv");
		vCtr++;
	}
	var ord = curProps.otfOrdinal;
	if (ord == true) {
		otf.push("\tOrdinaux\tactiv");
		vCtr++;
	}
	var fra = curProps.otfFraction;
	if (fra == true) {
		otf.push("\tFractions\tactiv");
		vCtr++;
	}
	var lig = curProps.otfDiscretionaryLigature;
	if (lig == true) {
		otf.push("\tLigatures cond.\tactiv");
		vCtr++;
	}
	var zer = curProps.otfSlashedZero;
	if (zer == true) {
		otf.push("\tZro barr\tactiv");
		vCtr++;
	}
	if (vCtr == 0) {
		otf.push("\tCases  cocher\taucune n'est active");
	}
	var ofs = curProps.otfFigureStyle;
	if (ofs == 1147563124) {
		otf.push("\tStyle de chiffre\tStyle de chiffre par dfaut");
	}
	else if (ofs == 1330932848) {
		otf.push("\tStyle de chiffre\tChiffres arabes alig. prop.");
	}
	else if (ofs == 1330933619) {
		otf.push("\tStyle de chiffre\tCaractres elzvir proport.");
	}
	else if (ofs == 1330931316) {
		otf.push("\tStyle de chiffre\tChiffres arabes alig. tabul.");
	}
	else if (ofs == 1330933620) {
		otf.push("\tStyle de chiffre\tCaractres elzvir tabulaires");
	}
	var pof = curProps.positionalForm;
	if (pof == 1852796517) {
		otf.push("\tFormes positionnelles\tForme gnrale");
	}
	else if (pof == 1634756205) {
		otf.push("\tFormes positionnelles\tForme automatique");
	}
	else if (pof == 1768843636) {
		otf.push("\tFormes positionnelles\tForme initiale");
	}
	else if (pof == 1835361385) {
		otf.push("\tFormes positionnelles\tForme mdiale");
	}
	else if (pof == 1718185569) {
		otf.push("\\tFormes positionnelles\tForme finale");
	}
	else if (pof == 1769172844) {
		otf.push("\tFormes positionnelles\tForme isole");
	}
	var oss = curProps.otfStylisticSets;
	var moreThanOne = false;
	if (oss == 1851876449 || oss == 0) {
		otf.push("\tJeux stylistiques\tAucun");
	}
	else {
		if      (oss ==       2) { oss =  "1"; }
		else if (oss ==       4) { oss =  "2"; }
		else if (oss ==       8) { oss =  "3"; }
		else if (oss ==      16) { oss =  "4"; }
		else if (oss ==      32) { oss =  "5"; }
		else if (oss ==      64) { oss =  "6"; }
		else if (oss ==     128) { oss =  "7"; }
		else if (oss ==     256) { oss =  "8"; }
		else if (oss ==     512) { oss =  "9"; }
		else if (oss ==    1024) { oss = "10"; }
		else if (oss ==    2048) { oss = "11"; }
		else if (oss ==    4096) { oss = "12"; }
		else if (oss ==    8192) { oss = "13"; }
		else if (oss ==   16384) { oss = "14"; }
		else if (oss ==   32768) { oss = "15"; }
		else if (oss ==   65536) { oss = "16"; }
		else if (oss ==  131072) { oss = "17"; }
		else if (oss ==  262144) { oss = "18"; }
		else if (oss ==  524288) { oss = "19"; }
		else if (oss == 1048576) { oss = "20"; }
		else {
			moreThanOne = true;
			if (oss == 2097150) {
				otf.push("\tJeux stylistiques\tJeux 1  20");
			}
			else {
				var valList = new Array (1048576, 524288, 262144, 131072, 65536, 32768, 16384, 8192, 4096, 2048, 1024, 512, 256, 128, 64, 32, 16, 8, 4, 2);
				var indList = new Array (20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1);
				var setList = new Array ();
				for (var i=0; i<20; i++) {
					curVal = oss - valList[i];
					if (curVal > 0) {
						oss = curVal;
						setList.push(indList[i]);
					}
					else if (oss == valList[i]) {
						setList.push(indList[i]);
						break;
					}
				}
				setList.reverse();
				setString = setList.join(", ");
				otf.push("\tJeux stylistiques\tJeux " + setString);
			}
		}
		if (!moreThanOne) {
			otf.push("\tJeux stylistiques\tJeu " + oss);
		}
	}
	var otfString = otf.join("\r");
	
	// **********************************************
	// le volet "Options de soulignement"
	// **********************************************
	var uac = curProps.underline;
	if (uac == false) {
		undString = "\tSouligner\tdsactiv";
	}
	else if (uac == 1851876449) {
		undString = "\tSouligner\tnon dfini";
	}
	else {
		var und = new Array ();
		var uCtr = 0;
		var unw = curProps.underlineWeight;
		if (unw == -9999) {
			und.push("\tEpaisseur\tAutomatique");
		}
		else if (unw == 1851876449) {
			und.push("\tEpaisseur\tnon dfinie");
			uCtr++;
		}
		else {
			und.push("\tEpaisseur\t" + unw + " pts");
		}
		var uno = curProps.underlineOffset;
		if (uno == -9999) {
			und.push("\tDcalage\tAutomatique");
		}
		else if (uno == 1851876449) {
			und.push("\tDcalage\tnon dfini");
			uCtr++;
		}
		else {
			und.push("\tDcalage\t" + uno + " pts");
		}
		try {
			var unt = curProps.underlineType.name;
			und.push("\tType\t" + unt);
		}
		catch (e) {
			und.push("\tType\tnon dfini");
			uCtr++;
		}
		var unc = curProps.underlineColor;
		if (unc == "Text Color") {
			unc = "(Couleur du texte)";
		}
		else {
			try {
				unc = unc.name;
				if (unc == "None") { unc = "[Sans]"; }
				else if (unc == "Black") { unc = "[Noir]"; }
				else if (unc == "Paper") { unc = "[Papier]"; }
				else if (unc == "Registration") { unc = "[Reprage]"; }
				und.push("\tCouleur\t" + unc);
			}
			catch (e) {
				und.push("\tCouleur\tnon dfinie");
				uCtr++;
			}
		}
		var uni = curProps.underlineTint;
		if (uni != 1851876449) {
			if (uni == -1) { uni = 100; }
			und.push("\tTeinte\t" + uni + "%");
		}
		else {
			und.push("\tTeinte\tnon dfinie");
			uCtr++;
		}
		var unop = curProps.underlineOverprint;
		if (unop == false) { unop = "non" }
		else if (unop == true) { unop = "oui"; }
		else if (unop == 1851876449) { 
			unop = "non dfinie";
			uCtr++;
		}
		und.push("\tSurimpression trait\t" + unop);
		var ugCtr = 0;
		if (unt != "Plein") {
			var ungc = curProps.underlineGapColor;
			if (ungc == "Text Color") {
				und.push("\tCouleur espace\t(Couleur du texte)");
			}
			else {
				try {
					ungc = ungc.name;
					if (ungc == "None") { ungc = "[Sans]"; }
					else if (ungc == "Black") { ungc = "[Noir]"; }
					else if (ungc == "Paper") { ungc = "[Papier]"; }
					else if (ungc == "Registration") { ungc = "[Reprage]"; }
					und.push("\tCouleur espace\t" + ungc);
				}
				catch (e) {
					und.push("\tCouleur espace\tnon dfinie");
					ugCtr++;
				}
			}
			var ungi = curProps.underlineGapTint;
			if (ungi != 1851876449) {
				if (ungi == -1) { ungi = 100; }
				und.push("\tTeinte espace\t" + ungi + "%");
			}
			else {
				und.push("\tTeinte espace\tnon dfinie");
				ugCtr++;
			}
			var ungo = curProps.underlineGapOverprint;
			if (ungo == false) { ungo = "non"; }
			else if (ungo == true) { ungo = "oui"; }
			else if (ungo == 1851876449) {
				ungo = "non dfinie";
				ugCtr++;
			}
			und.push("\tSurimpr. espace\t" + ungo);
		}
		else {
			ugCtr = 3;
		}
		if (uCtr == 6 && ugCtr == 3) {
			undString = "\tactiv\tmais rien n'est defini";
		}
		else {
			undString = und.join("\r");
		}
	}
	
	// **********************************************
	// le volet "Options de texte barr"
	// **********************************************
	var sac = curProps.strikeThru;
	if (sac == false) {
		var strString = "\tBarrer\tdsactiv";
	}
	else if (sac == 1851876449) {
		strString = "\tBarrer\tnon dfini";
	}
	else {
		var str = new Array ();
		var sCtr = 0;
		var stw = curProps.strikeThroughWeight;
		if (stw == -9999) {
			str.push("\tEpaisseur\tAutomatique");
		}
		else if (stw == 1851876449) {
			str.push("\tEpaisseur\tnon dfinie");
			sCtr++;
		}
		else {
			str.push("\tEpaisseur\t" + stw + " pts");
		}
		var sto = curProps.strikeThroughOffset;
		if (sto == -9999) {
			str.push("\tDcalage\tAutomatique");
		}
		else if (sto == 1851876449) {
			str.push("\tDcalage\tnon dfini");
			sCtr++;
		}
		else {
			str.push("\tDcalage\t" + sto + " pts");
		}
		try {
			var stt = curProps.strikeThroughType.name;
			str.push("\tType\t" + stt);
		}
		catch (e) {
			str.push("\tType\tnon dfini");
			sCtr++;
		}
		var stc = curProps.strikeThroughColor;
		if (stc == "Text Color") {
			stc = "(Couleur du texte)";
		}
		else {
			try {
				stc = stc.name;
				if (stc == "None") { stc = "[Sans]" }
				else if (stc == "Black") { stc = "[Noir]" }
				else if (stc == "Paper") { stc = "[Papier]" }
				else if (stc == "Registration") { stc = "[Reprage]" }
				str.push("\tCouleur\t" + stc);
			}
			catch (e) {
				str.push("\tCouleur\tnon dfinie");
				sCtr++;
			}
		}
		var sti = curProps.strikeThroughTint;
		if (sti != 1851876449) {
			if (sti == -1) { sti = 100; }
			str.push("\tTeinte\t" + sti + "%");
		}
		else {
			str.push("\tTeinte\tnon dfinie");
			sCtr++;
		}
		var skop = curProps.strikeThroughOverprint;
		if (skop == false) { skop = "non"; }
		else if (skop == true) { skop = "oui"; }
		else if (skop == 1851876449) { 
			skop = "non dfinie";
			sCtr++;
		}
		str.push("\tSurimpression trait\t" + skop);
		var sgCtr =0;
		if (stt != "Plein") {
			var stgc = curProps.strikeThroughGapColor;
			if (stgc == "Text Color") {
				str.push("\tCouleur espace\t(Couleur du texte)");
			}
			else {
				try {
					stgc = stgc.name;
					if (stgc == "None") { stgc = "[Sans]"; }
					else if (stgc == "Black") { stgc = "[Noir]"; }
					else if (stgc == "Paper") { stgc = "[Papier]"; }
					else if (stgc == "Registration") { stgc = "[Reprage]"; }
					str.push("\tCouleur espace\t" + stgc);
				}
				catch (e) {
					str.push("\tCouleur espace\tnon dfinie");
					sgCtr++;
				}
			}
			var stgi = curProps.strikeThroughGapTint;
			if (stgi != 1851876449) {
				if (stgi == -1) { stgi = 100; }
				str.push("\tTeinte espace\t" + stgi + "%");
			}
			else {
				str.push("\tTeinte espace\tnon dfinie");
				sgCtr++;
			}
			var stgo = curProps.strikeThroughGapOverprint;
			if (stgo == false) { stgo = "non"; }
			else if (stgo == true) { stgo = "oui"; }
			else if (stgo == undefined) { stgo = "non dfinie"; }
			else if (stgo == 1851876449) {
				stgo = "non dfinie";
				sgCtr++;
			}
			str.push("\tSurimpr. espace\t" + stgo);
		}
		else {
			sgCtr = 3;
		}
		if (sCtr == 6 && sgCtr == 3) {
			strString = "\tactiv\tmais rien n'est defini";
		}
		else {
			strString = str.join("\r");
		}
	}
	
	// **********************************************
	// crer un bloc texte
	var newFrame = newCharDoc.pages.item(-1).textFrames.add();
	if (pCtr%2==0 || oneStyle) {
		newFrame.properties = {geometricBounds:[12, 15, 285, 105.5]};
	}
	else {
		newFrame.properties = {geometricBounds:[12, 109.5, 285, 200]};
	}
	
	// prparer une nouvelle liste
	var propsList = new Array ();
	
	// ajouter les lments
	propsList.push("Document  " + docName);
	propsList.push("\r\tNom du style\t" + snm);
	propsList.push(genString);
	propsList.push("\rFormats de caractre de base");
	propsList.push(stdString);
	propsList.push("\rFormats de caractres avancs");
	propsList.push(advString);
	propsList.push("\rCouleur des caractres");
	propsList.push(colString);
	propsList.push("\rFonctionnalits OpenType");
	propsList.push(otfString);
	propsList.push("\rOptions de soulignement");
	propsList.push(undString);
	propsList.push("\rOptions de texte barr");
	propsList.push(strString);
	
	
	// convertir la liste en chane de caractres...
	var propsString = propsList.join("\r");
	// ... l'insrer dans le bloc texte...
	var curStory = newFrame.parentStory;
	curStory.contents = propsString;
	// ... et la formater
	try {
		curStory.appliedParagraphStyle = newCharDoc.paragraphStyles.itemByName("02_definitions");
	}
	catch (e) {
	}
	// formater les soustitres
	try {
		curStory.paragraphs.item(0).appliedParagraphStyle = newCharDoc.paragraphStyles.itemByName("01_soustitre");
	}
	catch (e) {
	}
	var nParas = curStory.paragraphs.length;
	for (var p=0; p<nParas; p++) {
		if (curStory.paragraphs[p].characters.length == 1) {
			try {
				curStory.paragraphs.item(p+1).appliedParagraphStyle = newCharDoc.paragraphStyles.itemByName("01_soustitre");
			}
			catch (e) {
			}
		}
	}
	// rtablir le style "Regular" pour quelques caractres
	try {
		curStory.paragraphs.item(0).characters.itemByRange(0, 9).fontStyle = "Regular";
	}
	catch (e) {
	}
	try {
		curStory.paragraphs.item(2).characters.itemByRange(0,13).fontStyle = "Regular";
	}
	catch (e) {
	}
	// tester le nombre de lignes de deux paragraphes et insrer un shift-return si ncessaire
	var testPara1 = curStory.paragraphs.item(2); // nom du style
	if (testPara1.lines.length == 2) {
		try {
			testPara1.characters.item(13).contents = 1397124194;
			testPara1.insertionPoints.item(14).contents = 1397909876;
		}
		catch (e) {
		}
	}
	var testPara2 = curStory.paragraphs.item(3+grp); // bas sur
	if (testPara2.lines.length == 2) {
		try {
			testPara2.characters.item(8).contents = 1397124194;
			testPara2.insertionPoints.item(9).contents = 1397909876;
		}
		catch (e) {
		}
	}
	
	// supprimer les Returns entre les paragraphes
	app.findTextPreferences = app.changeTextPreferences = null;
	app.findTextPreferences.findWhat = "\r\r";
	app.changeTextPreferences.changeTo = "\r";
	curStory.changeText();
	app.findTextPreferences = app.changeTextPreferences = null;
}

// une fonction pour extraire les units des rgles du document
function unitsEnumToString(x) {
	switch(x) {
		case 2054188905 :
			return " Pt"; // point
		case 2054187363 :
			return "p"; // pica
		case 2053729891 :
			return " pouce"; // pouce
		case 2053729892 :
			return " pouce"; // pouce dcimal
		case 2053991795 :
			return " mm"; // millimtres
		case 2053336435 :
			return " cm"; // centimtres
		case 2053335395 :
			return "c"; // cicros
		case 2051106676 :
			return " ag"; // agates
		case 2054187384 :
			return " px"; // pixels
		case 1131639917 :
			return " Pt"; // dfini par l'utilisateur
		default :
			return(" inconnu");
	}
}

// une fonction pour convertir les valeurs pica et cicro
function convVal(sm, val) {
	if (sm == "p" ||sm == "c") {
		if (val < 0) {
			val = (("" + val).slice(1))*1;
			vp = Math.floor(val);
			vx = (val - vp) * 12;
			return ("-" + vp + sm + vx);
		}
		else {
			vp = Math.floor(val);
			vx = (val - vp) * 12;
			return (vp + sm + vx);
		}
	}
	else {
		return (val + sm);
	}
}

// crer un nouveau document
function makeDoc() {
	with (app.marginPreferences){
		// mmoriser les prfrences des marges
		var oldY1 = top;
		var oldX1 = left;
		var oldY2 = bottom;
		var oldX2 = right;
		// modifier les valeurs des marges
		top = 0;
		left = 0;
		bottom = 0;
		right = 0;
	}
	// crer le document
	var newDoc = app.documents.add();
	newDoc.documentPreferences.properties = {pageWidth:210, pageHeight:297, facingPages:false};
	// dfinir les tabulations
	var mainTabs = new Array (2);
	mainTabs[0] = {alignment:TabStopAlignment.rightAlign, position:37};
	mainTabs[1] = {alignment:TabStopAlignment.leftAlign, position:41};
	// crer deux styles de paragraphes
	try {
		var pStyle1 = newDoc.paragraphStyles.add();
		pStyle1.name = "01_soustitre";
		pStyle1.properties = {pointSize:11, leading: 13, fillColor:"Black", fillTint:-1, 
			justification:Justification.leftAlign, alignToBaseline:false, tabList:mainTabs, 
			fontStyle:"Bold", spaceBefore:2, ruleAbove:true, ruleAboveLineWeight:.5, ruleAboveOffset:4};
	}
	catch (e) {
	}
	try {
		var pStyle2 = newDoc.paragraphStyles.add();
		pStyle2.name = "02_definitions";
		pStyle2.properties = {pointSize:11, leading: 13, fillColor:"Black", fillTint:-1, 
			justification:Justification.leftAlign, alignToBaseline:false, tabList:mainTabs};
	}
	catch (e) {
	}
	return [newDoc, oldY1, oldX1, oldY2, oldX2];
}

// restaurer les prfrences de l'application modifies
function restoreApp(oldY1, oldX1, oldY2, oldX2) {
	with (app.marginPreferences){
		top = oldY1;
		left = oldX1;
		bottom = oldY2;
		right = oldX2;
	}
}