//S3_ArrondirValeurs_504f.js
// 25.03.14 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Diminuer le nombre de position dcimales

// activer l'affichage des dialogues (mesure prventive)
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester si un document est ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// le document au premier plan
var curDoc = app.documents[0];

// vrifier, s'il y a des groupes de styles de paragraphes
paraGroups = curDoc.paragraphStyleGroups;
var nPSG = paraGroups.length;

// vrifier, s'il y a des groupes de styles de caractres
charGroups = curDoc.characterStyleGroups;
var nCSG = charGroups.length;

//--- dresser la liste des styles de paragraphes ---//
if (nPSG == 0) {
	var dlogPStyles = curDoc.paragraphStyles.everyItem().name;
// remplacer le contenu du premier lment par un astrisque
	dlogPStyles[0] = "*";
// insrer un lment vide au dbut
	dlogPStyles = [""].concat(dlogPStyles);
	nDlogPStyles = dlogPStyles.length;
}
else {
	pGroupNames = paraGroups.everyItem().name;
	pGroupNames = ["[Root]"].concat(pGroupNames);
	var dlogPStyles = curDoc.paragraphStyles.everyItem().name;
	// insrer trois espaces devant chaque nom
	for (var i=0; i<dlogPStyles.length; i++) {
		curName = "   " + dlogPStyles[i];
		dlogPStyles[i] = curName;
	}
	// remplacer le premier lment par "[Root]"
	dlogPStyles[0] = "[Root]";
	// insrer un astrisque au dbut
	dlogPStyles = ["*"].concat(dlogPStyles);
	// insrer un lment vide au dbut
	dlogPStyles = [""].concat(dlogPStyles);
	// une boucle  travers les groupes
	for (var i=0; i<nPSG; i++) {
		var curGroup = paraGroups[i];
		var curParaStyles = curGroup.paragraphStyles.everyItem().name;
		// insrer trois espaces devant chaque nom
		for (var k=0; k<curParaStyles.length; k++) {
			curName = "   " + curParaStyles[k];
			curParaStyles[k] = curName;
		}
		// insrer un lment avec le nom du groupe
		curParaStyles = [curGroup.name].concat(curParaStyles);
		dlogPStyles = dlogPStyles.concat(curParaStyles);
	}
	nDlogPStyles = dlogPStyles.length;
	// mmoriser les positions des noms des groupes
	var pGroupIDs = new Array ();
	pGroupIDs.push(0);
	for (var i=2; i<nDlogPStyles; i++) {
		if (dlogPStyles[i][0] != " ") {
			pGroupIDs.push(i);
		}
	}
	// inverser l'ordre de la liste
	pGroupIDs.reverse();
}

//--- dresser la liste des styles de caractres ---//
if (nCSG == 0) {
	var dlogCStyles = curDoc.characterStyles.everyItem().name;
	// remplacer le contenu du premier lment par un astrisque
	dlogCStyles[0] = "*";
	// insrer un lment vide au dbut
	dlogCStyles = [""].concat(dlogCStyles);
	nDlogCStyles = dlogCStyles.length;
}
else {
	cGroupNames = charGroups.everyItem().name;
	cGroupNames = ["[Root]"].concat(cGroupNames);
	var dlogCStyles = curDoc.characterStyles.everyItem().name;
	// insrer trois espaces devant chaque nom
	for (var i=0; i<dlogCStyles.length; i++) {
		curName = "   " + dlogCStyles[i];
		dlogCStyles[i] = curName;
	}
	// remplacer le premier lment par "[Root]"
	dlogCStyles[0] = "[Root]";
	// insrer un astrisque au dbut
	dlogCStyles = ["*"].concat(dlogCStyles);
	// insrer un lment vide au dbut
	dlogCStyles = [""].concat(dlogCStyles);
	// une boucle  travers les groupes
	for (var i=0; i<nCSG; i++) {
		var curGroup = charGroups[i];
		var curCharStyles = curGroup.characterStyles.everyItem().name;
		// insrer trois espaces devant chaque nom
		for (var k=0; k<curCharStyles.length; k++) {
			curName = "   " + curCharStyles[k];
			curCharStyles[k] = curName;
		}
		// insrer un lment avec le nom du groupe
		curCharStyles = [curGroup.name].concat(curCharStyles);
		dlogCStyles = dlogCStyles.concat(curCharStyles);
	}
	nDlogCStyles = dlogCStyles.length;
	// mmoriser les positions des noms des groupes
	var cGroupIDs = new Array ();
	cGroupIDs.push(0);
	for (var i=2; i<nDlogCStyles; i++) {
		if (dlogCStyles[i][0] != " ") {
			cGroupIDs.push(i);
		}
	}
	// inverser l'ordre de la liste
	cGroupIDs.reverse();
}

// effacer des dialogues qui sont ventuellement rests dans la mmoire
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

// crer un dialogue
var aDialog = app.dialogs.add({name:"Slectionner le style  modifier", canCancel:true});
with (aDialog) {
	with (dialogColumns.add()) {
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Style de paragraphes:"});
			staticTexts.add({staticLabel:" "});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var paraName = dropdowns.add({stringList:dlogPStyles, selectedIndex:0, minWidth:180});
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Style de caractres:"});
			staticTexts.add({staticLabel:" "});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var charName = dropdowns.add({stringList:dlogCStyles, selectedIndex:0, minWidth:180});
			}
		}
	}
	with (dialogColumns.add()) {
		staticTexts.add({staticLabel:"", minWidth:4});
	}
}
// montrer le dialogue
if (aDialog.show() == true) {
	// reprendre les choix de l'utilisateur
	var paraID = paraName.selectedIndex;
	var charID = charName.selectedIndex;
	// effacer le dialogue de la mmoire
	aDialog.destroy();
}
else {
	aDialog.destroy();
	exit();
}

// tester le choix de l'utilisateur
if (paraID != 0) {
	var curGroup;
	var curPara ;
	var grpName;
	var nParaStyles;
	if (paraID == 1) {
		var paraString = "";
		try {
			// quand l'astrisque a t slctionn, tenter de 
			// mmoriser le contenu du bloc texte "ParaStyles"
			paraString = curDoc.textFrames.itemByName("ParaStyles").parentStory.contents;
		}
		catch (e) {
		}
		if (paraString != "") {
			paraStyles = paraString.split("\r");
			nParaStyles = paraStyles.length;
			// s'il n'y a pas de groupes de styles
			if (nPSG == 0) {
				for (var s=0; s<nParaStyles; s++) {
					var curPara = paraStyles[s];
					roundParaVals(curPara, "");
				}
			}
			// le traitement des groupes est un peu plus compliqu
			else {
				for (var s=0; s<nParaStyles; s++) {
					var curPara = paraStyles[s];
					if (curPara[0] != " ") {
						grpName = curPara;
					}
					else {
						curPara = curPara.slice(3);
						roundParaVals(curPara, grpName);
					}
				}
			}
		}
		// si le bloc texte "ParaStyles" n'existe pas...
		else {
		// ... s'il n'y a pas de groupes de styles ...
			if (nPSG == 0) {
				for (var s=2; s<nDlogPStyles; s++) {
					var curPara = dlogPStyles[s];
					roundParaVals(curPara, grpName);
				}
			}
			// ... sinon, procder au traitement compliqu des groupes ...
			else {
				for (var s=2; s<nDlogPStyles; s++) {
					var curPara = dlogPStyles[s];
					if (curPara[0] != " ") {
						grpName = curPara;
						if (grpName != "[Root]") {
							var curGroup = curDoc.paragraphStyleGroups.itemByName(grpName);
							paraStyles = curGroup.allParagraphStyles;
							var nParaStyles = paraStyles.length;
							for (var j=0; j<nParaStyles; j++) {
								var curPara = paraStyles[j].name;
								roundParaVals(curPara, grpName);
							}
						}
						else {
							paraStyles = curDoc.paragraphStyles;
							var nParaStyles = paraStyles.length;
							for (var j=1; j<nParaStyles; j++) {
								var curPara = paraStyles[j].name;
								roundParaVals(curPara, grpName);
							}
						}
					}
				}
			}
		}
	}
	// lors du choix d'un autre article ce n'est que le style slectionn qui est trait ...
	else {
		curPara = dlogPStyles[paraID];
		// s'il n'y a pas de groupes, c'est plus simple ...
		if (nPSG == 0) {
			roundParaVals(curPara, "");
		}
		// ... sinon, il faut tenir compte des groupes
		else {
			// quand un nom de groupe est slectionn, le groupe entier est rpertori
			if (curPara[0] != " ") {
				grpName = curPara;
				if (grpName != "[Root]") {
					var curGroup = curDoc.paragraphStyleGroups.itemByName(grpName);
					paraStyles = curGroup.allParagraphStyles;
					var nParaStyles = paraStyles.length;
					for (var s=0; s<nParaStyles; s++) {
						var curPara = paraStyles[s].name;
						roundParaVals(curPara, grpName);
					}
				}
				else {
					paraStyles = curDoc.paragraphStyles;
					var nParaStyles = paraStyles.length;
					for (var s=1; s<nParaStyles; s++) {
						var curPara = paraStyles[s].name;
						roundParaVals(curPara, grpName);
					}
				}
			}
			// quand un nom de style est slectionn, il faut extraire le nom du groupe 
			else {
				grpName = undefined;
				// supprimer les trois espaces
				curPara = curPara.slice(3);
				// inverser la liste des noms des groupes
				pGroupNames.reverse();
				// une boucle  travers la listeiste
				for (var s=0; s<pGroupIDs.length; s++) {
					// lorsque la position du groupe est plus petit que celle du style
					// reprendre le nom
					if (pGroupIDs[s]<paraID) {
						grpName = pGroupNames[s];
						break;
					}
				}
				if (grpName != undefined) {
					roundParaVals(curPara, grpName);
				}
			}
		}
	}
}
// la mme action avec un style de caractres slectionn
if (charID != 0) {
	var charStyles;
	var curChar;
	var curGroup;
	var grpName;
	var nCharStyles;
	if (charID == 1) {
		var charString = "";
		try {
			var charString = curDoc.textFrames.itemByName("CharStyles").parentStory.contents;
		}
		catch (e) {
		}
		if (charString != "") {
			charStyles = charString.split("\r");
			nCharStyles = charStyles.length;
			if (nCSG == 0) {
				for (var s=0; s<nCharStyles; s++) {
					curChar = charStyles[s];
					roundCharVals(curChar, "");
				}
			}
			else {
				for (var s=0; s<nCharStyles; s++) {
					curChar = charStyles[s];
					if (curChar[0] != " ") {
						grpName = curChar;
					}
					else {
						curChar = curChar.slice(3);
						roundCharVals(curChar, grpName);
					}
				}
			}
		}
		else {
			if (nCSG == 0) {
				for (var s=2; s<nDlogCStyles; s++) {
					curChar = dlogCStyles[s];
					roundCharVals(curChar, "");
				}
			}
			else {
				for (var s=2; s<nDlogCStyles; s++) {
					curChar = dlogCStyles[s];
					if (curChar[0] != " ") {
						grpName = curChar;
						if (grpName != "[Root]") {
							curGroup = curDoc.characterStyleGroups.itemByName(grpName);
							charStyles = curGroup.allCharacterStyles;
							nCharStyles = charStyles.length;
							for (var j=0; j<nCharStyles; j++) {
								curChar = charStyles[j].name;
								roundCharVals(curChar, grpName);
							}
						}
						else {
							charStyles = curDoc.characterStyles;
							var nCharStyles = charStyles.length;
							for (var j=1; j<nCharStyles; j++) {
								var curChar = charStyles[j].name;
								roundCharVals(curChar, grpName);
							}
						}
					}
				}
			}
		}
	}
	else {
		curChar = dlogCStyles[charID];
		if (nCSG == 0) {
			roundCharVals(curChar, "");
		}
		else {
			if (curChar[0] != " ") {
				grpName = curChar;
				if (grpName != "[Root]") {
					curGroup = curDoc.characterStyleGroups.itemByName(grpName);
					charStyles = curGroup.allCharacterStyles;
					nCharStyles = charStyles.length;
					for (var s=0; s<nCharStyles; s++) {
						curChar = charStyles[s].name;
						roundCharVals(curChar, grpName);
					}
				}
				else {
					charStyles = curDoc.characterStyles;
					nCharStyles = charStyles.length;
					for (var s=1; s<nCharStyles; s++) {
						curChar = charStyles[s].name;
						roundCharVals(curChar, grpName);
					}
				}
			}
			else {
				grpName = undefined;
				curChar = curChar.slice(3);
				cGroupNames.reverse();
				for (var s=0; s<cGroupIDs.length; s++) {
					if (cGroupIDs[s]<charID) {
						grpName = cGroupNames[s];
						break;
					}
				}
				if (grpName != undefined) {
					roundCharVals(curChar, grpName);
				}
			}
		}
	}
}

// informer l'utilisateur
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Termin.");
dlog.show();
$.sleep(1000);
dlog.close();

//**********************************************************
// arrondir les valeurs des styles de paragraphes
//**********************************************************
function roundParaVals(curPara, grpName) {
	try {
		// mmoriser les attributs du style actuel
		if (nPSG == 0) {
			curPara = curDoc.paragraphStyles.itemByName(curPara);
			curProps = curPara.properties;
		}
		else {
			if (grpName != "[Root]") {
				var curGroup = curDoc.paragraphStyleGroups.itemByName(grpName);
				var curPara = curGroup.paragraphStyles.itemByName(curPara);
				curProps = curPara.properties;
			}
			else {
				curPara = curDoc.paragraphStyles.itemByName(curPara);
				curProps = curPara.properties;
			}
		}
	}
	catch (e) {
		return;
	}
	try {
		// Corps
		var siz = curProps.pointSize;
		siz = Math.floor((siz*1000) + 0.5) / 1000;
		// Interligne
		var led = curProps.leading;
		led = Math.floor((led*1000) + 0.5) / 1000;
		// Echelle horizontale
		var hsc = curProps.horizontalScale;
		hsc = Math.floor((hsc*1000) + 0.5) / 1000;
		// Dcalage vertical
		var bls = curProps.baselineShift;
		bls = Math.floor((bls*1000) + 0.5) / 1000;
		// Retrait  gauche
		var lin = curProps.leftIndent;
		lin = Math.floor((lin*1000) + 0.5) / 1000;
		// Retrait de 1re ligne
		var fln = curProps.firstLineIndent;
		fln = Math.floor((fln*1000) + 0.5) / 1000;
		// Retrait  droite
		var rin = curProps.rightIndent;
		rin = Math.floor((rin*1000) + 0.5) / 1000;
		// Espace avant
		var spb = curProps.spaceBefore;
		spb = Math.floor((spb*1000) + 0.5) / 1000;
		// Espace aprs
		var spa = curProps.spaceAfter;
		spa = Math.floor((spa*1000) + 0.5) / 1000;
		// Espace minimale
		var mws = curProps.minimumWordSpacing;
		mws = Math.floor(mws + 0.5);
		// Interligne auto
		var ald = curProps.autoLeading;
		ald = Math.floor(ald + 0.5);
		// appliquer les valeurs arrondies
		curPara.properties = {pointSize:siz, leading:led, horizontalScale:hsc, baselineShift:bls, leftIndent:lin, 
			firstLineIndent:fln, rightIndent:rin, spaceBefore:spb, spaceAfter:spa, minimumWordSpacing:mws, autoLeading:ald};
		
		// positions des tabulations
		var tbl = curProps.tabList;
		var nTabs = tbl.length;
		if (nTabs != 0) {
			for (var i=0; i<nTabs; i++) {
				var curPos = tbl[i].position;
				curPos = Math.floor((curPos*1000) + 0.5) / 1000;
				tbl[i].position = curPos;
			}
			// appliquer les valeurs arrondies
			curPara.properties = {tabList:tbl};
		}
		
		// Filet au-dessus
		var rab = curProps.ruleAbove;
		if (rab) {
			var raw = curProps.ruleAboveLineWeight;
			raw = Math.floor((raw*1000) + 0.5) / 1000;
			var rao = curProps.ruleAboveOffset;
			rao = Math.floor((rao*1000) + 0.5) / 1000;
			var rali = curProps.ruleAboveLeftIndent;
			rali = Math.floor((rali*1000) + 0.5) / 1000;
			var rari = curProps.ruleAboveRightIndent;
			rari = Math.floor((rari*1000) + 0.5) / 1000;
			// appliquer les valeurs arrondies
			curPara.properties = {ruleAboveLineWeight:raw, ruleAboveOffset:rao, ruleAboveLeftIndent:rali, ruleAboveRightIndent:rari};
		}
		// Filet au-dessous
		var rbe = curProps.ruleBelow;
		if (rbe) {
			var rbw = curProps.ruleBelowLineWeight;
			rbw = Math.floor((rbw*1000) + 0.5) / 1000;
			var rbo = curProps.ruleBelowOffset;
			rbo = Math.floor((rbo*1000) + 0.5) / 1000;
			var rbli = curProps.ruleBelowLeftIndent;
			rbli = Math.floor((rbli*1000) + 0.5) / 1000;
			var rbri = curProps.ruleBelowRightIndent;
			rbri = Math.floor((rbri*1000) + 0.5) / 1000;
			// appliquer les valeurs arrondies
			curPara.properties = {ruleBelowLineWeight:rbw, ruleBelowOffset:rbo, ruleBelowLeftIndent:rbli, ruleBelowRightIndent:rbri};
		}
	}
	catch (e) {
	}
}

//**********************************************************
// arrondir les valeurs des styles de caractres
//**********************************************************
function roundCharVals(curChar, grpName) {
		// mmoriser les attributs du style de caractres actuel
	try {
		if (nCSG == 0) {
			curChar = curDoc.characterStyles.itemByName(curChar);
			curProps = curChar.properties;
		}
		else {
			if (grpName != "[Root]") {
				var curGroup = curDoc.characterStyleGroups.itemByName(grpName);
				var curChar = curGroup.characterStyles.itemByName(curChar);
				curProps = curChar.properties;
			}
			else {
				curChar = curDoc.characterStyles.itemByName(curChar);
				curProps = curChar.properties;
			}
		}
	}
	catch (e) {
		return;
	}
	try {
		// Corps
		var siz = curProps.pointSize;
		siz = Math.floor((siz*1000) + 0.5) / 1000;
		// appliquer la valeur arrondie
		curChar.pointSize = siz;
	}
	catch (e) {
	}
	try {
		// Interligne
		var led = curProps.leading;
		led = Math.floor((led*1000) + 0.5) / 1000;
		// appliquer la valeur arrondie
		curChar.leading = led;
	}
	catch (e) {
	}
	try {
		// Echelle horizontale
		var hsc = curProps.horizontalScale;
		hsc = Math.floor((hsc*1000) + 0.5) / 1000;
		// appliquer la valeur arrondie
		curChar.horizontalScale = hsc;
	}
	catch (e) {
	}
	try {
		// Dcalage vertical
		var bls = curProps.baselineShift;
		bls = Math.floor((bls*1000) + 0.5) / 1000;
		// appliquer la valeur arrondie
		curChar.baselineShift = bls;
	}
	catch (e) {
	}
}